var schedule_data = schedule_data;
const url = schedule_data['url'];
const nonce = schedule_data['nonce'];
const action = schedule_data['action'];
const currency = schedule_data['currency'];
const dateFormat = schedule_data['dateFormat'];
const positionOfWeek = schedule_data['positionOfWeek'];
var settingList = schedule_data['list'];
var courseList = schedule_data['courseList'];
var formData = schedule_data['formData'];
var courseBool = schedule_data['courseBool'];
var courseName = schedule_data['courseName'];
var emailEnableList = schedule_data['emailEnable'];
var upgradeData = {url: schedule_data['url'], nonce: schedule_data['nonce'], action: schedule_data['action'], locale: schedule_data.locale};
var i18n = null;
var hotel = null;

var xmlHttp = null;
var date = {};
var buttonAction = null;
var selectedKey = null;
var visitors = {};

var blockPanel = null;
var contentPanel = null;
var editPanel = null;
var loadingPanel = null;
var buttonPanel = null;
var leftButtonPanel = null;
var rightButtonPanel = null;
var template_schedule_save_button = null;

var monthFullName = ['', 'January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December'];
var monthShortName = ['', 'Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'];
//var weekName = ['Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday'];
var weekName = ['Sun', 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat'];


    


window.onload = function(){
    
    console.log("dateFormat = " + dateFormat);
    
    i18n = new I18n(schedule_data.locale);
    i18n.setDictionary(booking_package_dictionary);
    
    hotel = new Hotel(currency, weekName, dateFormat, positionOfWeek, booking_package_dictionary);
    
    blockPanel = document.getElementById("blockPanel");
    contentPanel = document.getElementById("media_frame_reservation_content");
    editPanel = document.getElementById("editPanel");
    loadingPanel = document.getElementById("loadingPanel");
    buttonPanel = document.getElementById("buttonPanel");
    leftButtonPanel = document.getElementById("leftButtonPanel");
    rightButtonPanel = document.getElementById("rightButtonPanel");
    
    if(courseBool == 'true'){
        
        courseBool = true;
        
    }else{
        
        courseBool = false;
        
    }
    
    blockPanel.onclick = function(){
        
        leftButtonPanel.textContent = null;
        rightButtonPanel.textContent = null;
        editPanelShow(false);
        
    }
    
    document.getElementById("media_modal_close").onclick = function(){
        
        leftButtonPanel.textContent = null;
        rightButtonPanel.textContent = null;
        editPanelShow(false);
        
    }
    
    //var accountKey = schedule_data.calendarAccountList[0].key;
    var accountKey = getCookie(schedule_data.prefix + "accountKey");
    console.log("accountKey = " + accountKey);
    if(accountKey == null){
        
        accountKey = schedule_data.calendarAccountList[0].key;
        
    }else{
        
        var status = false;
        for(var i = 0; i < schedule_data.calendarAccountList.length; i++){
            
            var calendarAccount = schedule_data.calendarAccountList[i];
            if(accountKey == calendarAccount.key){
                
                status = true;
                break;
                
            }
            
        }
        
        if(status == false){
            
            accountKey = schedule_data.calendarAccountList[0].key;
            
        }
        
    }
    
    console.log("accountKey = " + accountKey);
    getReservationData(parseInt(schedule_data['month']), parseInt(schedule_data['day']), parseInt(schedule_data['year']), accountKey);
    
}

var getCookie = function(c_name){
    
    console.log("c_name = " + c_name);
    if(document.cookie.length > 0){
        
        var st = document.cookie.indexOf(c_name + "=");
        console.log(st);
        if(st != -1){
            
            st = st + c_name.length + 1;
            var ed = document.cookie.indexOf(";", st);
            if(ed == -1){
                
                ed = document.cookie.length;
                
            }
            
            var value = unescape(document.cookie.substring(st, ed));
            console.log("value = " + value);
            return value;
            
        }else {
            
            return null;
            
        }
        
    }
    
}

var getReservationData = function(month, day, year, accountKey, callback){
    
    loadingPanel.setAttribute("class", "loading_modal_backdrop");
    var post = {nonce: nonce, action: action, mode: 'getReservationData', year: year, month: month, day: 1, accountKey: accountKey};
    xmlHttp = new Booking_App_XMLHttp(url, post, function(calendarData){
            
        loadingPanel.setAttribute("class", "hidden_panel");
        console.log(calendarData);
        hotel.setCalendarAccount(calendarData.account);
        if(calendarData.courseList != null){
            
            courseList = calendarData.courseList;
            
        }
        
        if(calendarData.formData != null){
            
            formData = calendarData.formData;
            
        }
        
        if(callback == null){
            
            createCalendar(calendarData, month, day, year, accountKey);
            
        }else{
            
            callback(calendarData);
            
        }
        
        
            
    });
    
}

var selectCalendarAccount = function(calendarData, month, day, year, selectCalendarAccountPanel, calendarAccountList, accountKey){
    
    console.log("accountKey = " + accountKey);
    console.log(calendarAccountList);
    selectCalendarAccountPanel.id = "selectCalendarAccountPanel";
    var select = document.createElement("select");
    selectCalendarAccountPanel.appendChild(select);
    for(var i = 0; i < calendarAccountList.length; i++){
        
        var calendarAccount = calendarAccountList[i];
        console.log(calendarAccount);
        var option = document.createElement("option");
        option.value = calendarAccount.key;
        option.textContent = calendarAccount.name;
        select.appendChild(option);
        if(accountKey == calendarAccount.key){
            
            select.selectedIndex = i;
            courseBool = false;
            if(parseInt(calendarAccount.courseBool) == 1){
                
                courseBool = true;
                
            }
            
            console.log("courseBool = " + courseBool);
            courseName = calendarAccount.courseTitle;
            
        }
        
    }
    
    select.onchange = function(){
        
        console.log("onchange = " + this.selectedIndex);
        var key = this.selectedIndex;
        var accountKey = this.options[key].value;
        console.log("accountKey = " + accountKey);
        getReservationData(month, day, year, accountKey, null);
        
    }
    
}

var createCalendar = function(calendarData, month, day, year, accountKey){
    
    console.log(typeof month);
    this.date = {month: month, day: day, year: year};
    var calendarPanel = document.getElementById("calendarPage");
    calendarPanel.textContent = null;
    
    console.log("schedule_data.calendar_account = " + schedule_data.calendar_account);
    var selectCalendarAccountPanel = document.createElement("div");
    calendarPanel.appendChild(selectCalendarAccountPanel);
    selectCalendarAccount(calendarData, month, day, year, selectCalendarAccountPanel, schedule_data.calendarAccountList, accountKey);
    
    var dayHeight = parseInt(calendarPanel.clientWidth / 7);
	console.log("dayHeight = " + dayHeight);
	
	var weekName = [i18n.get('Sun'), i18n.get('Mon'), i18n.get('Tue'), i18n.get('Wed'), i18n.get('Thu'), i18n.get('Fri'), i18n.get('Sat')];
	var calendar = new Booking_App_Calendar(weekName, dateFormat, positionOfWeek, i18n);
	
	var datePanel = document.createElement("div");
	datePanel.setAttribute("class", "calendarData");
	datePanel.textContent = calendar.formatBookingDate(month, null, year, null, null, null, null);
	
	var returnLabel = document.createElement("label");
	returnLabel.setAttribute("class", "arrowLeft");
	if(month == 1){
	    
	    returnLabel.textContent = "＜" + calendar.formatBookingDate(12, null, null, null, null, null, null);
	    
	}else{
	    
	    returnLabel.textContent = "＜" + calendar.formatBookingDate((parseInt(month) - 1), null, null, null, null, null, null);
	    
	}
	
	var returnPanel = document.createElement("div");
	returnPanel.setAttribute("class", "calendarChangeButton");
	returnPanel.appendChild(returnLabel);
	
	var nextLabel = document.createElement("label");
	nextLabel.setAttribute("class", "arrowRight");
	if(month == 12){
	    
	    nextLabel.textContent = calendar.formatBookingDate(1, null, null, null, null, null, null) + "＞";
	    
	}else{
	    
	    nextLabel.textContent = calendar.formatBookingDate((parseInt(month) + 1), null, null, null, null, null, null) + "＞";
	    
	}
	var nextPanel = document.createElement("div");
	nextPanel.setAttribute("style", "text-align: right;");
	nextPanel.setAttribute("class", "calendarChangeButton");
	nextPanel.appendChild(nextLabel);
	
	var topPanel = document.createElement("div");
	topPanel.setAttribute("class", "calendarPanel");
	topPanel.appendChild(returnPanel);
	topPanel.appendChild(datePanel);
	topPanel.appendChild(nextPanel);
	calendarPanel.appendChild(topPanel);
	
	
	calendar.create(calendarPanel, calendarData, month, day, year, '', function(callback){
	    
	    console.log(callback);
	    var dayPanel = callback.eventPanel;
	    var day = parseInt(callback.day);
	    var remainderPanel = document.createElement("div");
        remainderPanel.setAttribute("class", "remainderPanel");
        remainderPanel.textContent = "0";
        var approved = 0;
        var pending = 0;
	    if(calendarData.reservation[callback.key] != null){
	        
	        var userList = calendarData.reservation[callback.key];
	        console.log(userList);
	        
	        for(var key in calendarData.reservation[callback.key]){
	            
	            console.log(calendarData.reservation[callback.key][key]);
	            if(calendarData.reservation[callback.key][key].status == 'approved'){
	                
	                approved++;
	                
	            }else if(calendarData.reservation[callback.key][key].status == 'pending'){
	                
	                pending++;
	                
	            }
	            
	        }
	        
	        console.log("approved = " + approved + " pending = " + pending);
	        var approvedCount = document.createElement("span");
	        approvedCount.classList.add("approvedCount");
	        approvedCount.textContent = approved;
	        
	        var pendingCount = document.createElement("span");
	        pendingCount.classList.add("pendingCount");
	        pendingCount.textContent = pending;
	        
	        remainderPanel.innerHTML = '<div class="approvedCount">' + approved + '</div>' + "/" + '<div class="pendingCount">' + pending + '</div>';
	        dayPanel.appendChild(remainderPanel);
	        
	        
	    }
	    
	    var total = approved + pending;
	    
	    if(calendarData.schedule[callback.key] != null && calendarData.schedule[callback.key].length != 0 || total != 0){
	        
	        dayPanel.onclick = function(){
			    	
			    //var dayKey = parseInt(this.getAttribute("data-key"));
			    var dayKey = parseInt(this.getAttribute("data-day"));
			    var monthKey = parseInt(this.getAttribute("data-month"));
			    var yearKey = parseInt(this.getAttribute("data-year"));
			    
			    buttonAction = "reservation_users";
			    document.getElementById("reservation_users").setAttribute("class", "media_menu_item active");
                document.getElementById("add_reservation").setAttribute("class", "media_menu_item");
			    //setCalendarDate({month: month, day: dayKey, year: year});
			    viewUserList(monthKey, dayKey, yearKey, calendarData, accountKey, function(callback){
		        	    
			        console.log("editPublicSchedule callback");
			        
			    });
			    
			    
		    }
		
	    }else{
	        
	        console.log("delete class");
	        dayPanel.classList.remove("pointer");
            dayPanel.classList.add("closeDay");
	        
	    }
	    
	});
	
	returnLabel.onclick = function(){
	    
	    if(month == 1){
			
			year--;
			month = 12;
			
		}else{
			
			month--;
			
		}
		
		getReservationData(month, 1, year, accountKey, null);
	    
	}
	
	nextLabel.onclick = function(){
	    
	    if(month == 12){
			
			year++;
			month = 1;
			
		}else{
			
			month++;
			
		}
		
		getReservationData(month, 1, year, accountKey, null);
	    
	}
    
}

var viewUserList = function(month, day, year, calendarData, accountKey, callback){
    
    var weekName = [i18n.get('Sun'), i18n.get('Mon'), i18n.get('Tue'), i18n.get('Wed'), i18n.get('Thu'), i18n.get('Fri'), i18n.get('Sat')];
	var calendar = new Booking_App_Calendar(weekName, dateFormat, positionOfWeek, i18n);
    var calendarKey = calendar.getDateKey(month, day, year);
    console.log(month + "/" + day + "/" + year);
    console.log("buttonAction = " + buttonAction);
    console.log(calendarData);
    console.log(calendarData.calendar[parseInt(calendarKey)].week);
    
    
    hotel.resetCheckDate();
    
    var edit_title = document.getElementById("edit_title");
    edit_title.textContent = calendar.formatBookingDate(month, day, year, null, null, null, calendarData.calendar[calendarKey].week);
    var media_menu = document.getElementById("media_menu");
    media_menu.textContent = null;
    
    contentPanel.setAttribute("class", "media_left_zero");
    document.getElementById("menu_panel").setAttribute("class", "media_frame_menu hidden_panel");
    document.getElementById("media_title").setAttribute("class", "media_left_zero");
    document.getElementById("media_router").setAttribute("class", "media_left_zero");
    document.getElementById("frame_toolbar").setAttribute("class", "media_frame_toolbar media_left_zero");
    
    var reservation_users_callback = function(response){
        
        console.log("reservation_users_callback");
        console.log("buttonAction = " + buttonAction);
        console.log(response);
        console.log(month + "/" + day + "/" + year);
        if(buttonAction == "updateSchedule"){
            
            viewUserList(response.month, response.day, response.year, response.calendarData, accountKey, callback);
            
        }else if(buttonAction == "updateSchedule"){
            
            viewUserList(month, day, year, response, accountKey, callback);
            
        }else{
            
            if(response.updateDate != null){
                
                if(response.account.type == "day"){
                    
                    viewUserList(response.updateDate.month, response.updateDate.day, response.updateDate.year, response, accountKey, callback);
                    
                }else{
                    
                    viewUserList(month, day, year, response, accountKey, callback);
                    
                }
                
                
            }else{
                
                viewUserList(month, day, year, response, accountKey, callback);
                
            }
            
        }
        
    }
    
    var add_reservation_callback = function(response){
        
        console.log(response);
        hotel.resetCheckDate();
        document.getElementById("reservation_users").setAttribute("class", "media_menu_item active");
        document.getElementById("add_reservation").setAttribute("class", "media_menu_item");
        viewUserList(month, day, year, response, accountKey, callback);
        
    }
    
    var changeButtonAction = function(buttonAction, mode, month, day, year, calendarData, add_reservationPanel, add_reservation_callback, callback){
        
        month = parseInt(month);
        day = parseInt(day);
        year = parseInt(year);
        //var lastDay = parseInt(calendarData.date.lastDay);
        var lastDay = 0;
        var key = parseInt(year + ("0" + month).slice(-2));
        if(calendarData.calendarList[key] != null){
            
            console.log(calendarData.calendarList[key]);
            lastDay = parseInt(calendarData.calendarList[key].lastDay);
            
        }
        var calendarChange = 0;
        hotel.resetCheckDate();
        
        console.log("month = " + month + " day = " + day + " year = " + year + " lastDay = " + lastDay);
        if(buttonAction == 'reservation_users' || buttonAction == 'add_reservation' || buttonAction == 'updateSchedule'){
            
            if(mode == 0){
                
                day--;
                if(day == 0){
                    
                    calendarChange = 1;
                    month--;
                    day = 1;
                    if(month == 0){
                        month = 12;
                        year--;
                    }
                    
                }
                
            }else if(mode == 1){
                
                day++;
                if(day > lastDay){
                    
                    calendarChange = 1;
                    month++;
                    day = 1;
                    if(month == 13){
                        month = 1;
                        year++;
                    }
                    
                }
                
            }
            
            console.log("calendarChange = " + calendarChange);
            if(calendarChange === 0){
                
                viewUserList(month, day, year, calendarData, accountKey, callback);
                
            }else{
                
                loadingPanel.setAttribute("class", "loading_modal_backdrop");
                var post = {nonce: nonce, action: action, mode: 'getReservationData', year: year, month: month, day: 1, accountKey: accountKey};
                xmlHttp = new Booking_App_XMLHttp(url, post, function(calendarData){
                    
                    loadingPanel.setAttribute("class", "hidden_panel");
                    console.log(calendarData);
                    createCalendar(calendarData, calendarData.date.month, calendarData.date.day, calendarData.date.year, accountKey);
                    var day = 1;
                    if(mode === 0){day = calendarData.date.lastDay;}
                    viewUserList(month, day, year, calendarData, accountKey, callback);
                    loadingPanel.setAttribute("class", "hidden_panel");
                    
                });
                
            }
            
        }else{
            
            console.log("month = " + month + " day = " + day + " year = " + year);
            var calendarKey = calendar.getDateKey(month, day, year);
            console.log(calendarKey);
            console.log(calendarData.reservation[calendarKey]);
            
            var reservationList = null;
            var selectedKey = null;
            if(calendarData.account.type == "day"){
                
                selectedKey = getSelectedKey();
                if(mode === 0){
                    
                    selectedKey--;
                    if(selectedKey < 0){
                        
                        selectedKey = calendarData.reservation[calendarKey].length - 1;
                        
                    }
                    
                }else{
                    
                    selectedKey++;
                    if(selectedKey == calendarData.reservation[calendarKey].length){
                        
                        selectedKey = 0;
                        
                    }
                    
                }
                setSelectedKey(selectedKey);
                reservationList = calendarData.reservation[calendarKey][selectedKey];
                console.log("selectedKey = " + selectedKey + " count = " + calendarData.reservation[calendarKey].length);
                
            }else{
                
                var key = getSelectedKey();
                var visitorsList = getVisitors();
                var visitorsArray = Object.keys(visitorsList);
                console.log(getVisitors())
                console.log(visitorsArray);
                if(mode === 0){
                    
                    key--;
                    if(key < 0){
                        
                        key = visitorsArray.length - 1;
                        
                    }
                    
                }else{
                    
                    key++;
                    if(key == visitorsArray.length){
                        
                        key = 0;
                        
                    }
                    
                }
                selectedKey = visitorsArray[key];
                setSelectedKey(key);
                reservationList = calendarData.reservationForHotel[visitorsList[selectedKey].checkIn][selectedKey];
                console.log("selectedKey = " + selectedKey);
                console.log(visitorsList[selectedKey]);
                console.log(calendarData.reservationForHotel[visitorsList[selectedKey].checkIn][selectedKey]);
                //return null;
                
            }
            
            /**
            console.log("selectedKey = " + selectedKey + " count = " + calendarData.reservation[calendarKey].length);
            var reservationList = calendarData.reservation[calendarKey][selectedKey];
            **/
            showUserInfo(selectedKey, calendarData, reservationList, false, accountKey, reservation_users_callback);
            
        }
        
    }
    
    var reservation_usersPanel = null;
    var add_reservationPanel = null;
    if(document.getElementById("reservation_usersPanel") != null && document.getElementById("add_reservationPanel") != null){
        
        reservation_usersPanel = document.getElementById("reservation_usersPanel");
        reservation_usersPanel.textContent = null;
        add_reservationPanel = document.getElementById("add_reservationPanel");
        add_reservationPanel.textContent = null;
        
    }else{
        
        reservation_usersPanel = document.createElement("div");
        reservation_usersPanel.id = "reservation_usersPanel";
        add_reservationPanel = document.createElement("div");
        add_reservationPanel.id = "add_reservationPanel";
        contentPanel.appendChild(reservation_usersPanel);
        contentPanel.appendChild(add_reservationPanel);
        
    }
    
    
    
    var menuTabList = {reservation_users: 'Reservation users', add_reservation: 'Add reservation'};
    for(var key in menuTabList){
        
        var tabPanel = document.getElementById(key);
        tabPanel.setAttribute("data-key", key);
        tabPanel.onclick = function(){
            
            var clickKey = this.getAttribute("data-key");
            for(var key in menuTabList){
                
                var link = document.getElementById(key);
                
                if(clickKey == key){
                    
                    link.setAttribute("class", "media_menu_item active");
                    
                }else{
                    
                    link.setAttribute("class", "media_menu_item");
                    
                }
                
                if(clickKey == 'reservation_users'){
                    
                    reservation_usersPanel.setAttribute("class", "");
                    add_reservationPanel.setAttribute("class", "hidden_panel");
                    reservation_users(reservation_usersPanel, month, day, year, calendarData, accountKey, reservation_users_callback);
                    
                }else if(clickKey == 'add_reservation'){
                    
                    if(document.getElementById("userInfoPanel") != null){
                        
                        var userPanel = document.getElementById("userInfoPanel");
                        if(userPanel.getAttribute("class") == "show_panel"){
                            
                            userPanel.setAttribute("class", "return_panel");
                            
                        }
                        
                    }
                    
                    if(document.getElementById("changePanel") != null){
                        
                        var changePanel = document.getElementById("changePanel");
                        if(changePanel.getAttribute("class") == "show_change_panel" || changePanel.getAttribute("class") == "return_change_panel"){
                            
                            changePanel.setAttribute("class", "return_panel");
                            
                        }
                        
                    }
                    
                    var blockPanelCount = contentPanel.getElementsByClassName("blockPanel");
                    for(var i = 0; i < blockPanelCount.length; i++){
                        
                        contentPanel.removeChild(blockPanelCount[i]);
                        
                    }
                    
                    hotel.reset();
                    reservation_usersPanel.setAttribute("class", "hidden_panel");
                    add_reservationPanel.setAttribute("class", "");
                    add_reservation(add_reservationPanel, month, day, year, calendarData, accountKey, add_reservation_callback);
                    
                    
                }
                
            }
            
        }
        
    }
    
    
    if(buttonAction == 'reservation_users' || buttonAction == 'updateSchedule' || buttonAction == 'showUserInfo'){
        
        reservation_users(reservation_usersPanel, month, day, year, calendarData, accountKey, reservation_users_callback);
        
    }else if(buttonAction == 'add_reservation'){
        
        
        add_reservation(add_reservationPanel, month, day, year, calendarData, accountKey, add_reservation_callback);
        
    }
    
    if(buttonAction != "updateSchedule"){
        
        leftButtonPanel.textContent = null;
        var beforButton = document.createElement("button");
        beforButton.id = "beforButton";
        beforButton.setAttribute("class", "beforButton button media-button button-primary button-large media-button-insert");
        //beforButton.setAttribute("style", "margin-left: 10px;");
        leftButtonPanel.appendChild(beforButton);
        
        var nextButton = document.createElement("button");
        nextButton.id = "nextButton";
        nextButton.setAttribute("class", "nextButton button media-button button-primary button-large media-button-insert");
        nextButton.setAttribute("style", "margin-left: 10px;");
        leftButtonPanel.appendChild(nextButton);
        
        var beforChangeButton = document.createElement("button");
        beforChangeButton.id = "beforChangeButton";
        beforChangeButton.setAttribute("class", "beforButton button media-button button-primary button-large media-button-insert hidden_panel");
        leftButtonPanel.appendChild(beforChangeButton);
        
        var nextChangeButton = document.createElement("button");
        nextChangeButton.id = "nextChangeButton";
        nextChangeButton.setAttribute("class", "nextButton button media-button button-primary button-large media-button-insert hidden_panel");
        nextChangeButton.setAttribute("style", "margin-left: 10px;");
        leftButtonPanel.appendChild(nextChangeButton);
        
        beforButton.onclick = function(){
            
            changeButtonAction(buttonAction, 0, month, day, year, calendarData, add_reservationPanel, add_reservation_callback, callback);
            
        }
        
        nextButton.onclick = function(){
            
            changeButtonAction(buttonAction, 1, month, day, year, calendarData, add_reservationPanel, add_reservation_callback, callback);
            
        }
        
        editPanelShow(true);
            
    }
    
    
    
    
    
    
    
}

var changeStatus = function(accountKey, reservation, statusClick, callback){
    
    var enable = false;
    var message = "";
    if(reservation.status == "approved"){
        
        message = i18n.get("Update to pending state about this operation?");
        if(Boolean(parseInt(emailEnableList.mail_pending.enable)) === false){
            
            console.log("mail_pending = " + Boolean(parseInt(emailEnableList.mail_pending.enable)));
            enable = true;
            
        }
        
    }else if(reservation.status == "pending"){
        
        message = i18n.get("Update to approval state about this operation?");
        if(Boolean(parseInt(emailEnableList.mail_approved.enable)) === false){
            
            console.log("mail_approved = " + Boolean(parseInt(emailEnableList.mail_approved.enable)));
            enable = true;
            
        }
        
    }
    var confirm = new Confirm();
    confirm.dialogPanelShow(i18n.get("Confirm send email"), i18n.get("Send email notification to customer and admin about this operation?"), enable, function(sendEmail){
        
        confirm.dialogPanelShow(i18n.get("Confirm contents update"), message, false, function(bool){
            
            if(bool === true){
                
                var status = "approved";
                if(reservation.status == "approved"){
                    status = "pending";
                }
                loadingPanel.setAttribute("class", "loading_modal_backdrop");
                var post = {nonce: nonce, action: action, mode: 'updateStatus', key: reservation.key, status: status, month: reservation.date.month, year: reservation.date.year, sendEmail: Number(sendEmail), accountKey: accountKey};
                xmlHttp = new Booking_App_XMLHttp(url, post, function(response){
                    
                    loadingPanel.setAttribute("class", "hidden_panel");
                    response.bookingStatus = status;
                    console.log(response);
                    createCalendar(response, response.date.month, response.date.day, response.date.year, accountKey);
                    callback(response);
                    
                });
                
            }
            
        });
        
        statusClick = false;
        
    });
    
}

var reservation_users = function(reservation_usersPanel, month, day, year, calendarData, accountKey, callback){
    
    console.log(calendarData.account.type);
    console.log("buttonAction = " + buttonAction);
    if(buttonAction != "updateSchedule" && buttonAction != "showUserInfo"){
        
        rightButtonPanel.textContent = null;
        buttonAction = "reservation_users";
        
    }else{
        
        
        
    }
    
    if(document.getElementById("userInfoPanel") != null){
        
        //document.getElementById("userInfoPanel").setAttribute("class", "hidden_panel");
        
    }
    
    var weekName = [i18n.get('Sun'), i18n.get('Mon'), i18n.get('Tue'), i18n.get('Wed'), i18n.get('Thu'), i18n.get('Fri'), i18n.get('Sat')];
	var calendar = new Booking_App_Calendar(weekName, dateFormat, positionOfWeek, i18n);
    var calendarKey = calendar.getDateKey(month, day, year);
    
    var reservationList = null;
    if(calendarData.account.type == 'day'){
        
        reservationList = calendarData.reservation[parseInt(calendarKey)];
        
    }else{
        
        reservationList = calendarData.reservationForHotel;
        
    }
    
    //var reservationList = calendarData.reservation[parseInt(calendarKey)];
    console.log(formData);
    console.log(reservationList);
    
    reservation_usersPanel.classList.remove("hidden_panel");
    reservation_usersPanel.textContent = null;
    
    if(reservationList == null){
        
        var errorPanel = document.createElement("div");
        errorPanel.setAttribute("class", "noReservations");
        errorPanel.textContent = i18n.get("No reservations");
        reservation_usersPanel.appendChild(errorPanel);
        return null;
        
    }
    
    var table = document.createElement("table");
    table.setAttribute("class", "wp-list-table widefat fixed striped");
    reservation_usersPanel.appendChild(table);
    
    if(calendarData.account.type == 'day'){
        
        if(reservationList != null){
            
            for(var i = 0; i < reservationList.length; i++){
            
                var userInfo = reservationList[i];
                console.log(userInfo);
                
                var tr = document.createElement("tr");
                tr.setAttribute("valign", "top");
                tr.setAttribute("data-key", i);
                table.appendChild(tr);
                
                var th = document.createElement("th");
                th.setAttribute("scope", "row");
                th.textContent = userInfo.date.hour + ":" + userInfo.date.min;
                tr.appendChild(th);
                
                var status = document.createElement("div");
                status.setAttribute("data-key", i);
                //console.log(i18n.get(userInfo.status.toUpperCase()));
                status.textContent = i18n.get(userInfo.status.toUpperCase());
                var statusClassName = "pendingLabel";
                if(userInfo.status == "approved"){
                    
                    statusClassName = "approvedLabel";
                    
                }
                status.classList.add(statusClassName)
                
                var td = document.createElement("td");
                td.setAttribute("scope", "row");
                td.appendChild(status);
                tr.appendChild(td);
                
                (function(fromData, praivateData, callback){
                    
                    var sort = [];
                    for(var i = 0; i < formData.length; i++){
                        
                        if(formData[i].active != 'true'){
                            
                            continue;
                            
                        }
                        
                        if(praivateData != null){
                            
                            for(var ii = 0; ii < praivateData.length; ii++){
                            
                                if(formData[i].id == praivateData[ii].id){
                                    
                                    sort[i] = praivateData[ii];
                                    break;
                                    
                                }
                                
                            }
                            
                            if(sort[i] == null){
                                
                                sort[i] = formData[i];
                                
                            }
                            
                        }else{
                            
                            break;
                            
                        }
                        
                    }
                    
                    callback(sort);
                    
                })(formData, userInfo.praivateData, function(praivateData){
                    
                    console.log(praivateData);
                    for(var i = 0; i < 5; i++){
                        
                        if(praivateData[i] != null){
                            
                            var td = document.createElement("td");
                            td.textContent = praivateData[i].value;
                            tr.appendChild(td);
                            
                        }
                        
                    }
                    
                });
                
                var statusClick = false;
                status.onclick = function(){
                    
                    var key = parseInt(this.getAttribute("data-key"));
                    console.log(key);
                    console.log(reservationList[key]);
                    statusClick = true;
                    
                    console.log(emailEnableList);
                    console.log("enable = " + Boolean(parseInt(emailEnableList.mail_new_admin.enable)));
                    
                    changeStatus(accountKey, reservationList[key], statusClick, callback);
                    
                    /**
                    var enable = false;
                    var message = "";
                    if(reservationList[key].status == "approved"){
                        
                        message = i18n.get("Update to pending state about this operation?");
                        if(Boolean(parseInt(emailEnableList.mail_pending.enable)) === false){
                            
                            console.log("mail_pending = " + Boolean(parseInt(emailEnableList.mail_pending.enable)));
                            enable = true;
                            
                        }
                        
                    }else if(reservationList[key].status == "pending"){
                        
                        message = i18n.get("Update to approval state about this operation?");
                        if(Boolean(parseInt(emailEnableList.mail_approved.enable)) === false){
                            
                            console.log("mail_approved = " + Boolean(parseInt(emailEnableList.mail_approved.enable)));
                            enable = true;
                            
                        }
                        
                    }
                    var confirm = new Confirm();
                    confirm.dialogPanelShow(i18n.get("Confirm send email"), i18n.get("Send email notification to customer and admin about this operation?"), enable, function(sendEmail){
                        
                        confirm.dialogPanelShow(i18n.get("Confirm contents update"), message, false, function(bool){
                            
                            if(bool === true){
                                
                                var status = "approved";
                                if(reservationList[key].status == "approved"){
                                    status = "pending";
                                }
                                loadingPanel.setAttribute("class", "loading_modal_backdrop");
                                var post = {nonce: nonce, action: action, mode: 'updateStatus', key: reservationList[key].key, status: status, month: calendarData.date.month, year: calendarData.date.year, sendEmail: Number(sendEmail), accountKey: accountKey};
                                xmlHttp = new Booking_App_XMLHttp(url, post, function(response){
                                    
                                    loadingPanel.setAttribute("class", "hidden_panel");
                                    console.log(response);
                                    createCalendar(response, response.date.month, response.date.day, response.date.year, accountKey);
                                    callback(response);
                                    
                                });
                                
                            }
                            
                        });
                        
                        statusClick = false;
                        
                    });
                    **/
                    
                }
                
                tr.onclick = function(){
                    
                    if(statusClick == false){
                        
                        var key = parseInt(this.getAttribute("data-key"));
                        console.log(key);
                        console.log(reservationList[key]);
                        setSelectedKey(key);
                        showUserInfo(key, calendarData, reservationList[key], true, accountKey, function(response){
                            
                            console.log(response);
                            if(response.status == "returnButton"){
                                
                                reservation_users(reservation_usersPanel, response.month, response.day, response.year, calendarData, accountKey, callback);
                                
                            }else{
                                
                                callback(response);
                                
                            }
                            
                        });
                        
                    }
                    
                }
                
            }
            
        }
        
    }else{
        
        var calendarArray = Object.keys(calendarData.calendar);
        var startKey = calendarData.calendar[calendarKey].number;
        var endKey = startKey + 7;
        
        if(calendarArray[endKey] == null){
            
            startKey = calendarArray.length - 7;
            endKey = calendarArray.length;
            
        }
        
        console.log("startKey = " + startKey + " endKey = " + endKey);
        console.log(calendarKey);
        console.log(calendarData.calendar);
        console.log(calendarArray);
        
        var tr = document.createElement("tr");
        tr.setAttribute("valign", "top");
        table.appendChild(tr);
        
        var visitorTr = document.createElement("tr");
        visitorTr.setAttribute("valign", "top");
        table.appendChild(visitorTr);
        
        var start = 0;
        var nights = 6;
        var end = 0;
        var left = 0;
        var visitors = {};
        calendar.setShortWeekNameBool(true);
        for(var i = startKey; i < endKey; i++){
            
            var key = calendarArray[i];
            end = key;
            var calendarInfo = calendarData.calendar[key];
            console.log("key = " + key);
            console.log(calendarInfo);
            
            
            (function(reservationList, date, start, nights, visitors){
                
                console.log(reservationList);
                console.log("date = " + date);
                console.log("start = " + start);
                
                for(var key in reservationList){
                    
                    var reservation = reservationList[key];
                    var id = reservation.key;
                    //console.log(reservation);
                    if(visitors[id] != null){
                        
                        var endDay = start;
                        
                        visitors[id].day++;
                        visitors[id].displayNights--;
                        visitors[id].endDay = endDay;
                        if(visitors[id].checkOut == date){
                            
                            visitors[id].checkOutBool = 1;
                            
                        }
                        console.log(visitors[id]);
                        
                    }else{
                        
                        var name = [];
                        for(var i = 0; i < reservation.praivateData.length; i++){
                            
                            var input = reservation.praivateData[i];
                            if(input.isName == "true"){
                                
                                name.push(input.value);
                                
                            }
                            
                        }
                        
                        name = name.join(" ");
                        var startDay = start;
                        if(date == parseInt(reservation.date.checkIn)){
                            
                            startDay = start + 0.5;
                            
                        }
                        
                        var endDay = start;
                        if(date == parseInt(reservation.date.checkIn)){
                            
                            endDay = start - 0.5;
                            
                        }
                        
                        //visitors[id] = {key: reservation.key, day: 0, status: reservation.status, nights: reservation.accommodationDetails.nights - nights, name: name, startDay: startDay, endDay: endDay, checkIn: parseInt(reservation.date.checkIn), checkOut: parseInt(reservation.date.checkOut)};
                        visitors[id] = {key: reservation.key, day: 0, status: reservation.status, nights: reservation.accommodationDetails.nights, displayNights: reservation.accommodationDetails.nights - start, name: name, startDay: startDay, endDay: endDay, checkIn: parseInt(reservation.date.checkIn), checkOut: parseInt(reservation.date.checkOut), checkOutBool: 0};
                        
                    }
                    
                    
                    
                }
                
            })(reservationList[key], key, start, nights, visitors);
            start++;
            nights--;
            
            var th = document.createElement("th");
            th.classList.add("text_center");
            th.setAttribute("scope", "row");
            th.textContent = calendar.formatBookingDate(null, calendarInfo.day, null, null, null, null, calendarInfo.week);
            tr.appendChild(th);
            console.log(th.clientWidth);
            
            
            var td = document.createElement("td");
            td.setAttribute("data-key", key);
            visitorTr.appendChild(td);
            
            //reservation_usersPanel
            var dayPanel = document.createElement("div");
            dayPanel.classList.add("weekHorizotalPanel");
            dayPanel.setAttribute("style", "left: " + left + "%;");
            reservation_usersPanel.appendChild(dayPanel);
            left += 14.2;
            
        }
        
        calendar.setShortWeekNameBool(false);
        
        console.log(visitors);
        setVisitors(visitors);
        console.log("end = " + end);
        
        var visitorListPanel = document.createElement("div");
        visitorListPanel.classList.add("visitorListPanel");
        reservation_usersPanel.appendChild(visitorListPanel);
        
        var i = 0;
        for(var key in visitors){
            
            console.log(visitors[key]);
            var width = 14.2 * visitors[key].day;
            var left = 14.2 * visitors[key].startDay;
            if(visitors[key].checkOut > end){
                
                width = 14.2 * (visitors[key].day + 0.5);
                
                
            }
            
            console.log("key = " + key + "width = " + (width + left));
            if(visitors[key].checkOutBool == 0 && visitors[key].day == 6){
                
                width = 99.4 - left;
                
            }else{
                
                if(visitors[key].startDay == 0){
                    
                    width += 7.1;
                    
                }
                
            }
            
            var visitorPanel = document.createElement("div");
            visitorPanel.setAttribute("style", "width: " + width + "%; left: " + left + "%;");
            visitorPanel.setAttribute("data-index", i);
            visitorPanel.setAttribute("data-key", key);
            visitorPanel.setAttribute("data-checkIn", visitors[key].checkIn);
            visitorPanel.classList.add("visitorPanel");
            visitorPanel.textContent = visitors[key].name;
            visitorListPanel.appendChild(visitorPanel);
            if(visitors[key].status == "pending"){
                
                visitorPanel.classList.add("visitorPendingPanel");
                
            }else{
                
                visitorPanel.classList.add("visitorApprovedPanel");
                
            }
            
            visitorPanel.onclick = function(){
                
                var key = this.getAttribute("data-key");
                console.log("key = " + key);
                console.log(visitors[key]);
                var key = parseInt(this.getAttribute("data-key"));
                var checkIn = parseInt(this.getAttribute("data-checkIn"));
                var index = parseInt(this.getAttribute("data-index"));
                setSelectedKey(index);
                console.log(key);
                console.log(reservationList[checkIn][key]);
                showUserInfo(key, calendarData, reservationList[checkIn][key], true, accountKey, function(response){
                    
                    console.log(response);
                    if(response.status == "returnButton"){
                        
                        reservation_users(reservation_usersPanel, response.month, response.day, response.year, calendarData, accountKey, callback);
                        
                    }else{
                        
                        callback(response);
                        
                    }
                    
                });
                
            }
            
            i++;
            
        }
        
        
    }
    
    console.log(th.clientWidth);
    
    /**
    if(reservationList != null){
        
        for(var i = 0; i < reservationList.length; i++){
        
            var userInfo = reservationList[i];
            console.log(userInfo);
            
            var tr = document.createElement("tr");
            tr.setAttribute("valign", "top");
            tr.setAttribute("data-key", i);
            table.appendChild(tr);
            
            var th = document.createElement("th");
            th.setAttribute("scope", "row");
            th.textContent = userInfo.date.hour + ":" + userInfo.date.min;
            tr.appendChild(th);
            
            var status = document.createElement("div");
            status.setAttribute("data-key", i);
            //console.log(i18n.get(userInfo.status.toUpperCase()));
            status.textContent = i18n.get(userInfo.status.toUpperCase());
            var statusClassName = "pendingLabel";
            if(userInfo.status == "approved"){
                
                statusClassName = "approvedLabel";
                
            }
            status.classList.add(statusClassName)
            
            var td = document.createElement("td");
            td.setAttribute("scope", "row");
            td.appendChild(status);
            tr.appendChild(td);
            
            (function(fromData, praivateData, callback){
                
                var sort = [];
                for(var i = 0; i < formData.length; i++){
                    
                    if(formData[i].active != 'true'){
                        
                        continue;
                        
                    }
                    
                    if(praivateData != null){
                        
                        for(var ii = 0; ii < praivateData.length; ii++){
                        
                            if(formData[i].id == praivateData[ii].id){
                                
                                sort[i] = praivateData[ii];
                                break;
                                
                            }
                            
                        }
                        
                        if(sort[i] == null){
                            
                            sort[i] = formData[i];
                            
                        }
                        
                    }else{
                        
                        break;
                        
                    }
                    
                }
                
                callback(sort);
                
            })(formData, userInfo.praivateData, function(praivateData){
                
                console.log(praivateData);
                for(var i = 0; i < 5; i++){
                    
                    if(praivateData[i] != null){
                        
                        var td = document.createElement("td");
                        td.textContent = praivateData[i].value;
                        tr.appendChild(td);
                        
                    }
                    
                }
                
            });
            
            var statusClick = false;
            status.onclick = function(){
                
                var key = parseInt(this.getAttribute("data-key"));
                console.log(key);
                console.log(reservationList[key]);
                statusClick = true;
                
                console.log(emailEnableList);
                console.log("enable = " + Boolean(parseInt(emailEnableList.mail_new_admin.enable)));
                
                
                
                
                var enable = false;
                var message = "";
                if(reservationList[key].status == "approved"){
                    
                    message = i18n.get("Update to pending state about this operation?");
                    if(Boolean(parseInt(emailEnableList.mail_pending.enable)) === false){
                        
                        console.log("mail_pending = " + Boolean(parseInt(emailEnableList.mail_pending.enable)));
                        enable = true;
                        
                    }
                    
                }else if(reservationList[key].status == "pending"){
                    
                    message = i18n.get("Update to approval state about this operation?");
                    if(Boolean(parseInt(emailEnableList.mail_approved.enable)) === false){
                        
                        console.log("mail_approved = " + Boolean(parseInt(emailEnableList.mail_approved.enable)));
                        enable = true;
                        
                    }
                    
                }
                var confirm = new Confirm();
                confirm.dialogPanelShow(i18n.get("Confirm send email"), i18n.get("Send email notification to customer and admin about this operation?"), enable, function(sendEmail){
                    
                    confirm.dialogPanelShow(i18n.get("Confirm contents update"), message, false, function(bool){
                        
                        if(bool === true){
                            
                            var status = "approved";
                            if(reservationList[key].status == "approved"){
                                status = "pending";
                            }
                            loadingPanel.setAttribute("class", "loading_modal_backdrop");
                            var post = {nonce: nonce, action: action, mode: 'updateStatus', key: reservationList[key].key, status: status, month: calendarData.date.month, year: calendarData.date.year, sendEmail: Number(sendEmail), accountKey: accountKey};
                            xmlHttp = new Booking_App_XMLHttp(url, post, function(response){
                                
                                loadingPanel.setAttribute("class", "hidden_panel");
                                console.log(response);
                                createCalendar(response, response.date.month, response.date.day, response.date.year, accountKey);
                                callback(response);
                                
                            });
                            
                        }
                        
                    });
                    
                    statusClick = false;
                    
                });
                
            }
            
            tr.onclick = function(){
                
                if(statusClick == false){
                    
                    var key = parseInt(this.getAttribute("data-key"));
                    console.log(key);
                    console.log(reservationList[key]);
                    setSelectedKey(key);
                    showUserInfo(key, calendarData, reservationList[key], true, accountKey, function(response){
                        
                        console.log(response);
                        if(response.status == "returnButton"){
                            
                            reservation_users(reservation_usersPanel, response.month, response.day, response.year, calendarData, accountKey, callback);
                            
                        }else{
                            
                            callback(response);
                            
                        }
                        
                    });
                    
                }
                
            }
            
        }
        
    }
    **/
    
}



var showUserInfo = function(key, calendarData, reservationData, animation, accountKey, callback){
    
    buttonAction = "showUserInfo";
    console.log("key = " + key);
    console.log("buttonAction = " + buttonAction);
    console.log(calendarData);
    console.log(reservationData);
    var infoPanel = null;
    if(document.getElementById("userInfoPanel") == null){
        
        infoPanel = document.createElement("div");
        infoPanel.id = "userInfoPanel";
        contentPanel.appendChild(infoPanel);
        
    }else{
        
        infoPanel = document.getElementById("userInfoPanel");
        
        
    }
    
    var blockPanel = null;
    if(animation === true){
        
        infoPanel.setAttribute("class", "show_panel");
        
        blockPanel = document.createElement("div");
        blockPanel.id = "showUserInfo_blockPanel"
        blockPanel.setAttribute("class", "blockPanel");
        contentPanel.insertBefore(blockPanel, infoPanel);
        
    }
    
    var deleteButton = document.createElement("button");
    deleteButton.id = "deleteButton";
    deleteButton.textContent = i18n.get("Delete", []);
    deleteButton.setAttribute("class", "button media-button button-primary button-large media-button-insert");
    
    var editButton = document.createElement("button");
    editButton.id = "editButton";
    editButton.textContent = i18n.get("Edit");
    editButton.setAttribute("class", "button media-button button-primary button-large media-button-insert");
    editButton.setAttribute("style", "margin-left: 10px;");
    
    rightButtonPanel.textContent = null;
    rightButtonPanel.appendChild(deleteButton);
    rightButtonPanel.appendChild(editButton);
    
    //document.getElementById("beforButton").classList.add("hidden_panel");
    
    var weekName = [i18n.get('Sun'), i18n.get('Mon'), i18n.get('Tue'), i18n.get('Wed'), i18n.get('Thu'), i18n.get('Fri'), i18n.get('Sat')];
	var calendar = new Booking_App_Calendar(weekName, dateFormat, positionOfWeek, i18n);
    
    infoPanel.textContent = null;
    
    var reservationDate = reservationData.date;
    var date = calendar.formatBookingDate(reservationDate.month, reservationDate.day, reservationDate.year, reservationDate.hour, reservationDate.min, reservationData.scheduleTitle, reservationData.date.week);
    
    var month = reservationData.date.month;
    var day = reservationData.date.day;
    var year = reservationData.date.year;
    
    console.log(date);
    
    var formPanel = document.createElement("div");
    formPanel.id = "inputFormPanel";
    infoPanel.appendChild(formPanel);
    
    var rowPanel = createRowPanel("ID", reservationData.key, null, null, null);
    formPanel.appendChild(rowPanel);
    
    var bookingTimeChange = document.createElement("div");
    bookingTimeChange.setAttribute("data-status", "1");
    bookingTimeChange.setAttribute("class", "change hidden_panel");
    bookingTimeChange.textContent = i18n.get("Change");
    
    var courseChange = document.createElement("div");
    courseChange.setAttribute("data-status", "1");
    courseChange.setAttribute("class", "change hidden_panel");
    courseChange.textContent = i18n.get("Change");
    
    
    if(calendarData.account.type == "hotel"){
        
        hotel.reset();
        hotel.setCallback(null);
        hotel.setNights(parseInt(reservationData.accommodationDetails.nights));
        
        var checkInDate = parseInt(reservationData.date.checkIn);
        var checkOutDate = parseInt(reservationData.date.checkOut);
        console.log("checkInDate = " + checkInDate + " checkOutDate = " + checkOutDate);
        /**
        var visitorsScheduleList = reservationData.accommodationDetails.scheduleList;
        var scheduleList = calendarData.schedule;
        for(var key in scheduleList){
            
            if(scheduleList[key][0] != null){
                
                hotel.addSchedule(scheduleList[key][0]);
                if(key >= checkInDate && key < checkOutDate){
                    
                    console.log(scheduleList[key][0]);
                    
                }
                
            }
            
        }
        **/
        
        var visitorsScheduleList = reservationData.accommodationDetails.scheduleDetails;
        var scheduleList = calendarData.schedule;
        for(var key in visitorsScheduleList){
            
            hotel.addSchedule(visitorsScheduleList[key]);
            
        }
        
        if(scheduleList[checkInDate] != null){
            
            hotel.setCheckIn(scheduleList[checkInDate][0]);
            
        }
        
        if(scheduleList[checkOutDate] != null){
            
            hotel.setCheckOut(scheduleList[checkOutDate][0]);
            
        }
        
        hotel.setCheckIn(reservationData.accommodationDetails.checkInSchedule);
        hotel.setCheckInKey(reservationData.accommodationDetails.checkInSchedule.key);
        hotel.setCheckOut(reservationData.accommodationDetails.checkOutSchedule);
        hotel.setCheckOutKey(reservationData.accommodationDetails.checkOutSchedule.key);
        
        console.log(hotel.getCheckDate());
        
        var statusPanel = createRowPanel(i18n.get("Status"), "", "status", "false", null);
        formPanel.appendChild(statusPanel);
        var statusLabel = document.getElementById("status");
        var className = "visitorApprovedPanel";
        var status = "APPROVED";
        if(reservationData.status == "pending"){
            
            className = "visitorPendingPanel";
            status = "PENDING";
            
        }
        statusLabel.classList.add(className);
        statusLabel.textContent = status;
        statusLabel.onclick = function(){
            
            console.log(this);
            changeStatus(accountKey, reservationData, null, function(response){
                
                console.log(response);
                if(response.status == "success"){
                    
                    var className = "visitorApprovedPanel";
                    var status = "APPROVED";
                    if(response.bookingStatus == "pending"){
                        
                        className = "visitorPendingPanel";
                        status = "PENDING";
                        
                    }
                    statusLabel.classList.add(className);
                    statusLabel.textContent = status;
                    
                    callback(response);
                    
                }
                
            });
            
        }
        
        
        var visitorsDetails = hotel.verifySchedule(false);
        console.log(visitorsDetails);
        
        var expressionsCheck = calendar.getExpressionsCheck(calendarData.account.expressionsCheck);
        
        var date = calendar.formatBookingDate(reservationData.date.checkIn_month, reservationData.date.checkIn_day, reservationData.date.checkIn_year, null, null, null, reservationData.date.checkIn_week);
        var checkIn = createRowPanel(expressionsCheck.arrival, date, "checkIn", "false", null);
        formPanel.appendChild(checkIn);
        document.getElementById("checkIn").setAttribute("data-id", reservationData.scheduleKey);
        
        date = calendar.formatBookingDate(reservationData.date.checkOut_month, reservationData.date.checkOut_day, reservationData.date.checkOut_year, null, null, null, reservationData.date.checkOut_week);
        var checkOut = createRowPanel(expressionsCheck.departure, date, "checkOut", "false", null);
        formPanel.appendChild(checkOut);
        
         var nightsValue = reservationData.accommodationDetails.nights + " nights";
        if(reservationData.accommodationDetails.nights == 1){
            
            nightsValue = reservationData.accommodationDetails.nights + " night";
            
        }
        var totalLengthOfStay = createRowPanel(i18n.get("Total length of stay"), nightsValue, null, null, null);
        formPanel.appendChild(totalLengthOfStay);
        
        var guestsList = reservationData.accommodationDetails.guestsList;
        for(var key in guestsList){
            
            var value = "None";
            var list = guestsList[key].json;
            console.log(typeof list);
            if(typeof list == "string"){
                
                list = JSON.parse(list);
                
            }else{
                
                guestsList[key].json = JSON.stringify(list);
                
            }
            
            guestsList[key].type = "SELECT";
            guestsList[key].value = 0;
            guestsList[key].index = 0;
            guestsList[key].person = 0;
            hotel.addGuests(key, guestsList[key]);
            var values = [];
            for(var i = 0; i < list.length; i++){
                
                if(parseInt(list[i].selected) == 1){
                    
                    console.log(list[i].name)
                    value = list[i].name;
                    guestsList[key].value = i;
                    guestsList[key].person = parseInt(list[i].number);
                    var response = hotel.setGuests(key, i, list[i].number);
                    
                }
                
                values.push(list[i].name);
                
            }
            
            guestsList[key].values = values;
            hotel.addGuests(key, guestsList[key]);
            var guestsPanel = createRowPanel(guestsList[key].name, value, "guests_" + guestsList[key].key, "false", null);
            formPanel.appendChild(guestsPanel);
            
        }
        
        console.log(hotel.getGuestsList());
        
        if(reservationData.accommodationDetails.adult != null && reservationData.accommodationDetails.children != null){
            
            var totalNumberOfGuests = parseInt(reservationData.accommodationDetails.adult) + parseInt(reservationData.accommodationDetails.children);
            var totalNumberOfGuestsValue = 0;
            if(totalNumberOfGuests > 1){
                
                totalNumberOfGuestsValue = totalNumberOfGuests + " " + i18n.get("people");
                
            }else if(totalNumberOfGuests == 1){
                
                totalNumberOfGuestsValue = totalNumberOfGuests + " " + i18n.get("person");
                
            }
            
            var totalNumberOfGuestsPanel = createRowPanel(i18n.get("Total number of guests"), String(totalNumberOfGuestsValue), "totalGuests", null, null);
            formPanel.appendChild(totalNumberOfGuestsPanel);
            
        }
        
        var summaryListPanel = document.createElement("div");
        summaryListPanel.id = "summaryListPanel";
        var summaryPanel = createRowPanel(i18n.get("Summary"), summaryListPanel, "summaryPanel", null, null);
        formPanel.appendChild(summaryPanel);
        hotel.showSummary(summaryListPanel, expressionsCheck);
        
        var totalPrice = formatCost(reservationData.accommodationDetails.additionalFee + reservationData.accommodationDetails.accommodationFee, currency);
        console.log("totalPrice = " + totalPrice);
        var rowPanel = createRowPanel(i18n.get("Total price"), totalPrice, "totalPrice", null, null);
        formPanel.appendChild(rowPanel);
        
    }else{
        
        var date = calendar.formatBookingDate(reservationDate.month, reservationDate.day, reservationDate.year, reservationDate.hour, reservationDate.min, reservationData.scheduleTitle, reservationData.date.week);
        var rowPanel = createRowPanel(i18n.get("Booking Date"), date, "booking_date", null, bookingTimeChange);
        formPanel.appendChild(rowPanel);
        document.getElementById("booking_date").setAttribute("data-key", reservationData.scheduleKey);
        document.getElementById("booking_date").setAttribute("data-unixTime", reservationData.scheduleUnixTime);
        
        if(reservationData.courseKey.length != 0 && reservationData.courseName.length != 0){
            
            var rowPanel = createRowPanel(courseName, reservationData.courseName, "booking_course", null, courseChange);
            formPanel.appendChild(rowPanel);
            document.getElementById("booking_course").setAttribute("data-key", reservationData.courseKey);
            document.getElementById("booking_course").setAttribute("data-time", reservationData.courseTime);
            
        }
        
        var cost = 0;
        if(reservationData.scheduleCost != null){
            
            cost += parseInt(reservationData.scheduleCost);
            
        }
        
        if(reservationData.courseCost != null){
            
            cost += parseInt(reservationData.courseCost);
            
        }
        
        if(cost != 0){
            
            cost = formatCost(cost, reservationData.currency);
            var rowPanel = createRowPanel(i18n.get("Price"), cost, "booking_cost", null, null);
            formPanel.appendChild(rowPanel);
            
        }
        
    }
    
    
    
    if(reservationData.payId == "stripe"){
        
        var rowPanel = createRowPanel("Charge token", reservationData.payToken, "booking_cost", null, null);
        formPanel.appendChild(rowPanel);
        
    }
    
    var formPanelList = [];
    var formData = reservationData.praivateData;
    if(formData != null){
        
        for(var i = 0; i < formData.length; i++){
            
            var rowPanel = createRowPanel(formData[i]['name'], formData[i]['value'], null, null, null);
            rowPanel.setAttribute("data-key", i);
            if(formData[i].active != null && formData[i].active != 'true'){
                
                //continue;
                rowPanel.classList.add("hidden_panel");
                
            }
            formPanel.appendChild(rowPanel);
            formPanelList.push(rowPanel);
            
        }
        
    }
    
    var cancelToEdit = function(){
        
        bookingTimeChange.classList.add("hidden_panel");
        bookingTimeChange.setAttribute("data-status", "1");
        bookingTimeChange.textContent = i18n.get("Change");
        courseChange.classList.add("hidden_panel");
        courseChange.setAttribute("data-status", "1");
        courseChange.textContent = i18n.get("Change");
        
        
        var date = calendar.formatBookingDate(reservationData.date.month, reservationData.date.day, reservationData.date.year, reservationData.date.hour, reservationData.date.min, reservationData.scheduleTitle, reservationData.date.week);
        if(document.getElementById("booking_date") != null){
            
            console.log("date = " + date);
            var dateLabel = document.getElementById("booking_date");
            dateLabel.setAttribute("data-key", reservationData.scheduleKey);
            dateLabel.setAttribute("data-unixTime", reservationData.scheduleUnixTime);
            dateLabel.textContent = date;
            
        }
        
        if(reservationData.courseKey != null && reservationData.courseTime != null && document.getElementById("booking_course") != null){
            
            console.log(reservationData);
            var courseLabel = document.getElementById("booking_course");
            courseLabel.setAttribute("data-key", reservationData.courseKey);
            courseLabel.setAttribute("data-time", reservationData.courseTime);
            courseLabel.textContent = reservationData.courseName;
            
        }
        
        if(document.getElementById("booking_cost") != null){
                        
            var cost = formatCost(reservationData.courseCost, reservationData.currency);
            document.getElementById("booking_cost").textContent = cost;
            
        }
        
        document.getElementById("beforButton").classList.remove("hidden_panel");
        document.getElementById("nextButton").classList.remove("hidden_panel");
        document.getElementById("beforChangeButton").classList.add("hidden_panel");
        document.getElementById("nextChangeButton").classList.add("hidden_panel");
        
        var responseData = {};
        if(calendarData.account.type == "hotel"){
            
            var guestsList = hotel.getGuestsList();
            for(var key in guestsList){
                
                console.log(guestsList[key]);
                var guestsParentPanel = document.getElementById("guests_" + key).parentElement;
                var guestsPanel = document.getElementById("guests_" + key);
                var guestsSelectPanel = document.getElementById("select_guests_" + key);
                guestsPanel.classList.remove("hidden_panel");
                console.log(guestsSelectPanel);
                if(guestsSelectPanel != null){
                    
                    guestsParentPanel.removeChild(guestsSelectPanel);
                    
                }
                
            }
            
            var totalNumberOfGuests = parseInt(reservationData.accommodationDetails.adult) + parseInt(reservationData.accommodationDetails.children);
            totalNumberOfGuestsPanel.classList.remove("errorPanel");
            document.getElementById("totalGuests").textContent = totalNumberOfGuests;
            
            //responseData = {status: "returnButton", month: month, day: day, year: year, calendarData: calendarData};
            
        }else{
            
            var edit_title = document.getElementById("edit_title");
            edit_title.textContent = calendar.formatBookingDate(reservationData.date.month, reservationData.date.day, reservationData.date.year, null, null, null, reservationData.date.week);
            /**
            month = reservationData.date.month;
            day = reservationData.date.day;
            year = reservationData.date.year;
            responseData = {status: "returnButton", month: month, day: day, year: year, calendarData: calendarData};
            **/
        }
        
        console.log(calendarData);
        console.log(reservationData);
        
        month = reservationData.date.month;
        day = reservationData.date.day;
        year = reservationData.date.year;
        responseData = {status: "returnButton", month: month, day: day, year: year, calendarData: calendarData};
        
        //buttonAction = "reservation_users";
        //callback(responseData);
        
    };
    
    
    if(blockPanel != null){
        
        blockPanel.onclick = function(event){
            
            console.log("blockPanel click");
            buttonAction = "reservation_users";
            rightButtonPanel.textContent = null;
            if(document.getElementById("changePanel") != null){
                
                document.getElementById("changePanel").setAttribute("class", "return_panel");
                
            }
            infoPanel.setAttribute("class", "return_panel");
            contentPanel.removeChild(blockPanel);
            
            cancelToEdit();
            
            
        }
        
    }
    
    var object = this;
    editButton.onclick = function(){
        
        document.getElementById("beforButton").classList.add("hidden_panel");
        document.getElementById("nextButton").classList.add("hidden_panel");
        
        bookingTimeChange.classList.remove("hidden_panel");
        courseChange.classList.remove("hidden_panel");
        
        /**
         * var extensionsFunction = new ExtensionsFunction();
        extensionsFunction.edtiBookingUser(object, editButton, deleteButton, rightButtonPanel, formPanel, changePanel, reservationDate, reservationData, formPanelList, formData, function(response){
            
            rightButtonPanel.textContent = null;
            response.action = 'refresh';
            buttonAction = "reservation_users";
            createCalendar(response, response.date.month, response.date.day, response.date.year);
            callback(response);
            
        });
        return null;
        **/
        
        editButton.setAttribute("class", "hidden_panel");
        deleteButton.setAttribute("class", "hidden_panel");
        
        var returnButton = document.createElement("button");
        returnButton.id = "returnButton";
        returnButton.textContent = i18n.get("Return");
        returnButton.setAttribute("class", "button media-button button-primary button-large media-button-insert");
        returnButton.setAttribute("style", "margin-left: 10px;");
        rightButtonPanel.appendChild(returnButton);
        
        var saveButton = document.createElement("button");
        saveButton.id = "saveButton";
        saveButton.textContent = i18n.get("Save");
        saveButton.setAttribute("class", "button media-button button-primary button-large media-button-insert");
        saveButton.setAttribute("style", "margin-left: 10px;");
        rightButtonPanel.appendChild(saveButton);
        
        var inputPanelList = {};
        var inputData = {};
        var input = new Input();
        
        if(calendarData.account.type == "hotel"){
            
            /**
            var value = input.createInput(i, form, inputData, null);
            var rowPanel = createRowPanel(form.name, value, null, form.required, null);
            **/
            var visitorsDetails = hotel.verifySchedule(false);
            console.log(visitorsDetails);
            if(visitorsDetails.status == true){
                
                var guestsList = hotel.getGuestsList();
                for(var key in guestsList){
                    
                    console.log(guestsList[key]);
                    var value = input.createInput(key, guestsList[key], inputData, function(event){
                        
                        var key = this.parentElement.getAttribute("data-guset");
                        var index = parseInt(this.selectedIndex);
                        var list = JSON.parse(guestsList[key].json);
                        guestsList[key].index = index;
                        var response = hotel.setGuests(key, index, list[index].number);
                        var feeList = hotel.getFeeList();
                        document.getElementById("totalGuests").textContent = response.person;
                        //document.getElementById("additionalFee").textContent = formatCost((feeList.additionalFee * response.nights), currency);
                        if(response.booking == false || response.nights == 0 || response.requiredGuests == false){
                            
                            saveButton.disabled = true;
                            
                        }else{
                            
                            saveButton.disabled = false;
                            
                        }
                        
                        totalNumberOfGuestsPanel.classList.remove("errorPanel");
                        if(response.booking == false){
                            
                            totalNumberOfGuestsPanel.classList.add("errorPanel");
                        
                        }
                        
                        console.log(totalNumberOfGuestsPanel);
                        
                        console.log(response);
                        console.log(this.selectedIndex);
                        console.log(guestsList[key]);
                        console.log(list[index]);
                        
                    });
                    value.id = "select_guests_" + key;
                    value.setAttribute("data-guset", key);
                    console.log(value);
                    var guestsParentPanel = document.getElementById("guests_" + key).parentElement;
                    var guestsPanel = document.getElementById("guests_" + key);
                    guestsPanel.classList.add("hidden_panel");
                    guestsParentPanel.appendChild(value);
                    console.log(guestsPanel);
                    guestsPanel = value;
                    
                }
                
            }
            
            /**
            var guestsList = hotel.getGuestsList();
            for(var key in guestsList){
                
                console.log(guestsList[key]);
                var value = input.createInput(key, guestsList[key], inputData, function(event){
                    
                    console.log(this);
                    var key = this.parentElement.getAttribute("data-guset");
                    var index = parseInt(this.selectedIndex);
                    var list = JSON.parse(guestsList[key].json);
                    guestsList[key].index = index;
                    var response = hotel.setGuests(key, index, list[index].number);
                    var feeList = hotel.getFeeList();
                    document.getElementById("totalGuests").textContent = response.person;
                    document.getElementById("additionalFee").textContent = formatCost((feeList.additionalFee * response.nights), currency);
                    if(response.booking == false || response.nights == 0 || response.requiredGuests == false){
                        
                        saveButton.disabled = true;
                        
                    }else{
                        
                        saveButton.disabled = false;
                        
                    }
                    
                    totalNumberOfGuestsPanel.classList.remove("errorPanel");
                    if(response.booking == false){
                        
                        totalNumberOfGuestsPanel.classList.add("errorPanel");
                    
                    }
                    
                    console.log(totalNumberOfGuestsPanel);
                    
                    console.log(response);
                    console.log(this.selectedIndex);
                    console.log(guestsList[key]);
                    console.log(list[index]);
                    
                });
                value.id = "select_guests_" + key;
                value.setAttribute("data-guset", key);
                console.log(value);
                var guestsParentPanel = document.getElementById("guests_" + key).parentElement;
                var guestsPanel = document.getElementById("guests_" + key);
                //guestsParentPanel.removeChild(guestsPanel);
                guestsPanel.classList.add("hidden_panel");
                guestsParentPanel.appendChild(value);
                console.log(guestsPanel);
                guestsPanel = value;
                
            }
            **/
            
        }
        
        
        for(var i = 0; i < formPanelList.length; i++){
            
            //var key = parseInt(formPanelList[i].getAttribute("data-key"));
            var form = formData[i];
            console.log(i + " name = " + form.name);
            formPanel.removeChild(formPanelList[i]);
            var value = input.createInput(i, form, inputData, null);
            var rowPanel = createRowPanel(form.name, value, null, form.required, null);
            if(form.active != 'true'){
                
                rowPanel.classList.add("hidden_panel");
                
            }
            inputPanelList[i] = rowPanel;
            //inputPanelList.push(rowPanel);
            formPanel.appendChild(rowPanel);
            
        }
        
        console.log(formPanelList);
        saveButton.onclick = function(){
            
            var date = {month: (reservationDate.month + 1), day: reservationDate.day, year: reservationDate.year};
            var schedule = {key: reservationData.scheduleKey, unixTime: reservationData.scheduleUnixTime};
            var course = {key: reservationData.courseKey};
            if(reservationData.courseKey == null){
                course = null
            }
            
            var valueList = {};
            var post = verifyForm("updateBooking", nonce, action, date, schedule, course, formData, inputPanelList, inputData, valueList);
            var booking_date = null;
            if(calendarData.account.type == "day"){
                
                booking_date = document.getElementById("booking_date").getAttribute("data-key");
                
            }else{
                
                booking_date = document.getElementById("checkIn").getAttribute("data-id");
                
            }
            console.log(booking_date);
            if(booking_date != reservationData.scheduleKey){
                
                post['update_booking_date'] = booking_date;
                
            }
            
            
            if(calendarData.account.type == "hotel"){
                
                post.json = JSON.stringify(hotel.verifySchedule(false));
                
            }
            
            if(document.getElementById("booking_course") != null && document.getElementById("booking_course").getAttribute("data-key") != reservationData.courseKey){
                
                var booking_course = document.getElementById("booking_course").getAttribute("data-key");
                console.log(booking_course);
                post['update_booking_course'] = booking_course;
                
            }
            
            post.month = parseInt(month);
            post.day = parseInt(day);
            post.year = year;
            console.log(post);
            //return null;
            
            if(post !== false){
                
                
                loadingPanel.setAttribute("class", "loading_modal_backdrop");
                post.accountKey = accountKey;
                post.updateKey = reservationData.key;
                console.log(post);
                xmlHttp = new Booking_App_XMLHttp(url, post, function(response){
                    
                    console.log(response);
                    if(response.status == "success"){
                        
                        hotel.reset();
                        hotel.setCallback(null);
                        var updateDate = {month: parseInt(month), day: parseInt(day), year: year};
                        response.updateDate = updateDate;
                        
                        rightButtonPanel.textContent = null;
                        response.action = 'refresh';
                        buttonAction = "reservation_users";
                        createCalendar(response, response.date.month, response.date.day, response.date.year, accountKey);
                        callback(response);
                        contentPanel.removeChild(blockPanel);
                        infoPanel.setAttribute("class", "return_panel");
                        if(document.getElementById("changePanel") != null){
                
                            document.getElementById("changePanel").setAttribute("class", "return_panel");
                            
                        }
                        
                    }else{
                        
                        alert(response);
                        
                    }
                    loadingPanel.setAttribute("class", "hidden_panel");
                    
                });
                
            }
            
        }
        
        returnButton.onclick = function(){
            
            var edit_title = document.getElementById("edit_title");
            edit_title.textContent = calendar.formatBookingDate(reservationData.date.month, reservationData.date.day, reservationData.date.year, null, null, null, null);
            
            if(document.getElementById("changePanel") != null && document.getElementById("changePanel").getAttribute("class") != "return_panel"){
                
                document.getElementById("changePanel").setAttribute("class", "return_change_panel");
                
            }
            
            /**
            var date = formatBookingDate(dateFormat, reservationData.date.month, reservationData.date.day, reservationData.date.year, reservationData.date.hour, reservationData.date.min, reservationData.scheduleTitle, null);
            var dateLabel = document.getElementById("booking_date");
            dateLabel.setAttribute("data-key", reservationData.scheduleKey);
            dateLabel.setAttribute("data-unixTime", reservationData.scheduleUnixTime);
            dateLabel.textContent = date;
            
            //document.getElementById("booking_course").setAttribute("data-time", reservationData.courseTime);
            var courseLabel = document.getElementById("booking_course");
            courseLabel.setAttribute("data-key", reservationData.courseKey);
            courseLabel.setAttribute("data-time", reservationData.courseTime);
            courseLabel.textContent = reservationData.courseName;
            
            document.getElementById("beforButton").classList.remove("hidden_panel");
            document.getElementById("nextButton").classList.remove("hidden_panel");
            document.getElementById("beforChangeButton").classList.add("hidden_panel");
            document.getElementById("nextChangeButton").classList.add("hidden_panel");
            **/
            
            rightButtonPanel.removeChild(returnButton);
            rightButtonPanel.removeChild(saveButton);
            editButton.setAttribute("class", "button media-button button-primary button-large media-button-insert");
            deleteButton.setAttribute("class", "button media-button button-primary button-large media-button-insert");
            for(var key in inputPanelList){
                
                formPanel.removeChild(inputPanelList[key]);
                //var form = formData[i];
                var rowPanel = createRowPanel(formData[key]['name'], formData[key]['value'], null, null, null);
                if(formData[key].active != 'true'){
                    
                    rowPanel.classList.add("hidden_panel");
                    
                }
                formPanelList[key] = rowPanel;
                formPanel.appendChild(rowPanel);
            
            }
            
            /**
            console.log(calendarData);
            console.log(reservationData);
            month = reservationData.date.month;
            day = reservationData.date.day;
            year = reservationData.date.year;
            var responseData = {status: "returnButton", month: month, day: day, year: year, calendarData: calendarData};
            //buttonAction = "reservation_users";
            callback(responseData);
            **/
            
            cancelToEdit();
            buttonAction = "showUserInfo";
            
        }
        
        
    }
    
    deleteButton.onclick = function(){
        
        console.log(emailEnableList);
        console.log("enable = " + Boolean(parseInt(emailEnableList.mail_deleted.enable)));
        
        var enable = false;
        if(Boolean(parseInt(emailEnableList.mail_deleted.enable)) === false){
            
            enable = true;
            
        }
        console.log("enable = " + enable);
        
        var confirm = new Confirm();
        
        var refoundBool = true;
        if(reservationData.payToken != null && reservationData.payToken.length != 0){
            
            refoundBool = false;
            
        }
        console.log(reservationData.payToken);
        
        confirm.dialogPanelShow(i18n.get("Refund confirmation"), i18n.get("This booking has been paid by credit card. Do you refund the price to the customer?"), refoundBool, function(refoundValue){
            
            console.log("refoundValue = " + refoundValue);
            confirm.dialogPanelShow(i18n.get("Confirm send email"), i18n.get("Send email notification to customer and admin about this operation?"), enable, function(sendEmail){
                
                console.log("sendEmail = " + sendEmail);
                console.log("sendEmail = " + parseInt(sendEmail));
                confirm.dialogPanelShow(i18n.get("Confirm deletion of data"), i18n.get("Do you delete the booking about this operation?"), false, function(result){
                    
                    console.log(result);
                    if(result == true){
                        
                        loadingPanel.setAttribute("class", "loading_modal_backdrop");
                        var post = {nonce: nonce, action: action, mode: 'deleteBookingData', key: reservationData.key, sendEmail: Number(sendEmail), refound: Number(refoundValue), accountKey: accountKey};
                        xmlHttp = new Booking_App_XMLHttp(url, post, function(response){
                            
                            console.log(response);
                            if(response.status == 'success'){
                                
                                hotel.reset();
                                hotel.setCallback(null);
                                rightButtonPanel.textContent = null;
                                console.log(blockPanel);
                                if(blockPanel != null){
                                    
                                    contentPanel.removeChild(blockPanel);
                                    
                                }
                                
                                infoPanel.setAttribute("class", "return_panel");
                                if(document.getElementById("changePanel") != null){
                                    
                                    document.getElementById("changePanel").setAttribute("class", "return_panel");
                                    
                                }
                                buttonAction = "reservation_users";
                                createCalendar(response, response.date.month, response.date.day, response.date.year, accountKey);
                                callback(response);
                                
                            }
                            loadingPanel.setAttribute("class", "hidden_panel");
                            
                        });
                        
                    }
                    
                });
                
            });
            
        });
        
        
        
        
    }
    
    var month = reservationData.date.month;
    var day = reservationData.date.day;
    var year = reservationData.date.year;
    var confirm = new Confirm;
    
    bookingTimeChange.onclick = function(){
        
        if(typeof ExtensionsFunction != "function"){
            
            confirm.alertPanelShow(i18n.get("Warning"), i18n.get("Please upgrade your free plan to enable this feature."), false, null);
            return null;
            
        }
        
        var data_status = parseInt(bookingTimeChange.getAttribute("data-status"));
        if(data_status == 1){
            
            data_status = 0;
            bookingTimeChange.textContent = i18n.get("Change");
            courseChange.classList.add("hidden_panel");
            createToChangePanelForTimeOrCourse(month, day, year, reservationData, calendarData, "date", accountKey, function(response){
                
                console.log("bookingTimeChange.onclick");
                console.log(response);
                if(response.status == "statusButton"){
                    
                    calendarData = response.calendarData;
                    bookingTimeChange.setAttribute("data-status", response.value);
                    bookingTimeChange.textContent = i18n.get("Change");
                    courseChange.classList.remove("hidden_panel");
                    document.getElementById("beforChangeButton").classList.add("hidden_panel");
                    document.getElementById("nextChangeButton").classList.add("hidden_panel");
                    
                }else if(response.status == "statusButton"){
                    
                    
                    
                }else{
                    
                    if(response.month != null && response.day != null && response.year != null){
                        
                        month = response.month;
                        day = response.day;
                        year = response.year;
                        
                    }
                    
                    calendarData = response.calendarData;
                    callback(response);
                    
                }
                
                
            });
            
        }else{
            
            data_status = 1;
            bookingTimeChange.textContent = i18n.get("Change");
            courseChange.classList.remove("hidden_panel");
            document.getElementById("beforButton").classList.add("hidden_panel");
            document.getElementById("nextButton").classList.add("hidden_panel");
            document.getElementById("beforChangeButton").classList.remove("hidden_panel");
            document.getElementById("nextChangeButton").classList.remove("hidden_panel");
            document.getElementById("changePanel").setAttribute("class", "return_change_panel");
            
        }
        bookingTimeChange.setAttribute("data-status", data_status);
        
        
    }
    
    
    courseChange.onclick = function(){
        
        if(typeof ExtensionsFunction != "function"){
            
            confirm.alertPanelShow(i18n.get("Warning"), i18n.get("Please upgrade your free plan to enable this feature."), false, null);
            return null;
            
        }
        
        var data_status = parseInt(courseChange.getAttribute("data-status"));
        if(data_status == 1){
            
            data_status = 0;
            courseChange.textContent = i18n.get("Change");
            bookingTimeChange.classList.add("hidden_panel");
            createToChangePanelForTimeOrCourse(month, day, year, reservationData, calendarData, "course", accountKey, function(response){
                
                console.log(response);
                if(response.status == "statusButton"){
                    
                    calendarData = response.calendarData;
                    courseChange.setAttribute("data-status", response.value);
                    courseChange.textContent = i18n.get("Change");
                    bookingTimeChange.classList.remove("hidden_panel");
                    
                }else if(response.status == "statusButton"){
                    
                    
                    
                }else{
                    
                    if(response.month != null && response.day != null && response.year != null){
                        
                        month = response.month;
                        day = response.day;
                        year = response.year;
                        
                    }
                    
                    calendarData = response.calendarData;
                    callback(response);
                    
                }
                
                
            });
            
        }else{
            
            data_status = 1;
            courseChange.textContent = i18n.get("Change");
            bookingTimeChange.classList.remove("hidden_panel");
            document.getElementById("beforButton").classList.add("hidden_panel");
            document.getElementById("nextButton").classList.add("hidden_panel");
            document.getElementById("changePanel").setAttribute("class", "return_change_panel");
            
        }
        courseChange.setAttribute("data-status", data_status);
        
    }
    
}

var createToChangePanelForTimeOrCourse = function(month, day, year, reservationData, calendarData, changeAction, accountKey, callback){
    
    console.log("month = " + month + " day = " + day + " year = " + year);
    var weekName = [i18n.get('Sun'), i18n.get('Mon'), i18n.get('Tue'), i18n.get('Wed'), i18n.get('Thu'), i18n.get('Fri'), i18n.get('Sat')];
	var calendar = new Booking_App_Calendar(weekName, dateFormat, positionOfWeek, i18n);
	var calendarKey = calendar.getDateKey(month, day, year);
    
    var edit_title = document.getElementById("edit_title");
    edit_title.textContent = calendar.formatBookingDate(month, day, year, null, null, null, calendarData.calendar[calendarKey].week);
    
    var changePanel = null;
    if(document.getElementById("changePanel") == null){
        
        changePanel = document.createElement("div");
        changePanel.id = "changePanel";
        contentPanel.appendChild(changePanel);
        
    }else{
        
        changePanel = document.getElementById("changePanel");
        
    }
    changePanel.classList.add("hidden_panel");
    console.log("month = " + month + " day = " + day + " year = " + year);
    document.getElementById("beforButton").classList.add("hidden_panel");
    document.getElementById("nextButton").classList.add("hidden_panel");
    var beforChangeButton = document.getElementById("beforChangeButton");
    var nextChangeButton = document.getElementById("nextChangeButton");
    
    if(changeAction == "date"){
        buttonAction = "updateSchedule";
        beforChangeButton.classList.remove("hidden_panel");
        nextChangeButton.classList.remove("hidden_panel");
    }else{
        buttonAction = "showUserInfo";
    }
    
    var changeButtonAction = function(mode, month, day, year, calendarData){
        
        console.log("mode = " + mode);
        console.log("buttonAction = " + buttonAction);
        if(buttonAction != 'updateSchedule'){
            
            return null;
            
        }
        
        month = parseInt(month);
        day = parseInt(day);
        year = parseInt(year);
        var lastDay = parseInt(calendarData.date.lastDay);
        
        console.log("month = " + month + " day = " + day + " year = " + year + " lastDay = " + lastDay);
        var date = verifyCalendar(mode, month, day, year, lastDay);
        if(date.calendarChange === 0){
            
            createToChangePanelForTimeOrCourse(date.month, date.day, date.year, reservationData, calendarData, changeAction, accountKey, callback);
            callback({month: date.month, day: date.day, year: date.year, calendarData: calendarData});
            
        }else{
            
            loadingPanel.setAttribute("class", "loading_modal_backdrop");
            var post = {nonce: nonce, action: action, mode: 'getReservationData', year: date.year, month: date.month, day: 1, accountKey: accountKey};
            xmlHttp = new Booking_App_XMLHttp(url, post, function(calendarData){
                
                loadingPanel.setAttribute("class", "hidden_panel");
                console.log(calendarData);
                var day = 1;
                if(mode === 0){day = calendarData.date.lastDay;}
                createToChangePanelForTimeOrCourse(date.month, day, date.year, reservationData, calendarData, changeAction, accountKey, callback);
                callback({month: date.month, day: day, year: date.year, calendarData: calendarData});
                loadingPanel.setAttribute("class", "hidden_panel");
                
            });
            
        }
        
    }
    
    changePanel.textContent = null;
    changePanel.setAttribute("class", "show_change_panel");
    //var day = reservationData.date.day;
    var dateLabel = document.getElementById("booking_date");
    var courseLabel = document.getElementById("booking_course");
    var courseTime = null;
    if(courseLabel != null){
        
        courseTime = courseLabel.getAttribute("data-time");
        
    }
    console.log(courseLabel);
    
    var extensionsFunction = new ExtensionsFunction();
    var response = extensionsFunction.preparToUpdateSchedule(reservationData, calendarData, parseInt(courseTime), changeAction);
    var updateSchedule = response.schedule;
    var scheduleAll = response.scheduleAll;
    day = parseInt(day);
    console.log(calendarData);
    console.log("day = " + parseInt(day));
    console.log(updateSchedule);
    console.log(updateSchedule[calendarKey]);
    console.log(reservationData);
    
    var dateLabel = document.getElementById("booking_date");
    
    if(changeAction == "date"){
        
        if(updateSchedule[calendarKey].length == 0){
            
            console.error("error = schedule zero");
            var errorPanel = document.createElement("div");
            errorPanel.setAttribute("class", "noSchedule");
            errorPanel.textContent = i18n.get("No schedules");
            changePanel.appendChild(errorPanel);
            
        }
        
        var userScheduleKey = dateLabel.getAttribute("data-key");
        
        var scheduleListPanel = [];
        for(var i = 0; i < updateSchedule[calendarKey].length; i++){
            
            var schedule = updateSchedule[calendarKey][i];
            schedule["select"] = true;
            if(parseInt(schedule["remainder"]) == 0 || schedule["stop"] == 'true'){
                
                schedule["select"] = false;
                
            }
            
            var schedulePanel = document.createElement("div");
            schedulePanel.textContent = ("0" + schedule["hour"]).slice(-2) + ":" + ("0" + schedule["min"]).slice(-2) + " " + schedule['title'];
            schedulePanel.setAttribute("data-key", i);
            scheduleListPanel.push(schedulePanel);
            
            if(schedule["select"] === true){
                
                schedulePanel.setAttribute("data-status", 1);
                schedulePanel.setAttribute("class", "courseAndScheduleRow");
                schedulePanel.onclick = function(){
                    
                    this.setAttribute("class", "courseAndScheduleRow courseAndScheduleRowActive");
                    var key = this.getAttribute("data-key");
                    var schedule = calendarData['schedule'][calendarKey][key];
                    unselectPanel(key, scheduleListPanel, "courseAndScheduleRow");
                    console.log(schedule);
                    var hour = (0 + schedule["hour"]).slice(-2);
                    var min = (0 + schedule["min"]).slice(-2);
                    var date = calendar.formatBookingDate(schedule.month, schedule.day, schedule.year, hour, min, schedule.title, null);
                    
                    dateLabel.setAttribute("data-key", schedule.key);
                    dateLabel.setAttribute("data-unixTime", schedule.unixTime);
                    dateLabel.textContent = date;
                    
                    document.getElementById("beforChangeButton").classList.add("hidden_panel");
                    document.getElementById("nextChangeButton").classList.add("hidden_panel");
                    document.getElementById("changePanel").setAttribute("class", "return_change_panel");
                    callback({status: "statusButton", value: "1", calendarData: calendarData});
                    
                }
                
                if(userScheduleKey == schedule.key){
                    
                    console.log("onClick");
                    schedulePanel.setAttribute("class", "courseAndScheduleRow courseAndScheduleRowActive");
                    unselectPanel(i, scheduleListPanel, "courseAndScheduleRow");
                    
                }
                
            }else{
                
                schedulePanel.setAttribute("data-status", 0);
                schedulePanel.setAttribute("class", "courseAndScheduleRowError");
                
            }
            
            var table_row = document.createElement("div");
            table_row.appendChild(schedulePanel);
            
            changePanel.appendChild(table_row);
            
        }
        
    }else if(changeAction == 'course'){
        
        console.log(courseList);
        //var start = parseInt(dateLabel.getAttribute("data-unixTime"));
        var time = parseInt(dateLabel.getAttribute("data-unixTime"));
        for(var i = 0; i < updateSchedule[calendarKey].length; i++){
            
            var schedule = updateSchedule[calendarKey][i];
            if(time < parseInt(schedule.unixTime) && schedule.remainder <= 0){
                
                console.log(schedule);
                time = (schedule.unixTime - time) / 60;
                break;
                
            }
            
        }
        console.log("time = " + time);
        
        var courseLabel = document.getElementById("booking_course");
        var userCourseKey = courseLabel.getAttribute("data-key");
        
        var courseListPanel = [];
        for(var i = 0; i < courseList.length; i++){
            
            var courseData = courseList[i];
            courseData["select"] = true;
            if(time < courseData.time){
                courseData["select"] = false;
            }
            console.log(courseData);
            
            var coursePanel = document.createElement("div");
            //coursePanel.textContent = courseData.name;
            coursePanel.setAttribute("data-key", i);
            
            
            var courseNamePanel = document.createElement("span");
            courseNamePanel.textContent = courseData.name;
            coursePanel.appendChild(courseNamePanel);
            
            if(courseData.cost != null){
                
                var cost = formatCost(courseData.cost, reservationData.currency);
                var courseCostPanel = document.createElement("span");
                courseCostPanel.classList.add("courseCostPanel");
                courseCostPanel.textContent = cost;
                coursePanel.appendChild(courseCostPanel);
                
            }
            
            
            courseListPanel.push(coursePanel);
            
            if(courseData["select"] === true){
                
                coursePanel.setAttribute("data-status", 1);
                coursePanel.setAttribute("class", "courseAndScheduleRow");
                coursePanel.onclick = function(){
                    
                    this.setAttribute("class", "courseAndScheduleRow courseAndScheduleRowActive");
                    var key = this.getAttribute("data-key");
                    var courseData = courseList[key];
                    unselectPanel(key, courseListPanel, "courseAndScheduleRow");
                    courseLabel.setAttribute("data-key", courseData.key);
                    courseLabel.setAttribute("data-time", courseData.time);
                    courseLabel.textContent = courseData.name;
                    
                    if(document.getElementById("booking_cost") != null){
                        
                        var cost = formatCost(courseData.cost, reservationData.currency);
                        document.getElementById("booking_cost").textContent = cost;
                        
                    }
                    
                    document.getElementById("beforChangeButton").classList.add("hidden_panel");
                    document.getElementById("nextChangeButton").classList.add("hidden_panel");
                    document.getElementById("changePanel").setAttribute("class", "return_change_panel");
                    callback({status: "statusButton", value: "1", calendarData: calendarData});
                    
                };
                
                if(courseData.key == userCourseKey){
                    
                    console.log("onClick");
                    coursePanel.setAttribute("class", "courseAndScheduleRow courseAndScheduleRowActive");
                    unselectPanel(i, courseListPanel, "courseAndScheduleRow");
                    
                }
                
            }else{
                
                coursePanel.setAttribute("data-status", 0);
                coursePanel.setAttribute("class", "courseAndScheduleRowError");
                
            }
            
            
            
            var table_row = document.createElement("div");
            table_row.appendChild(coursePanel);
            
            changePanel.appendChild(table_row);
            
        }
        
    }
    
    
    
    beforChangeButton.onclick = function(){
        
        console.log("day = " + day);
        changeButtonAction(0, month, day, year, calendarData);
        
    }
    
    nextChangeButton.onclick = function(){
        
        console.log("day = " + day);
        changeButtonAction(1, month, day, year, calendarData);
        
    }
    
}

var add_reservation = function(add_reservationPanel, month, day, year, calendarData, accountKey, callback){
    
    buttonAction = "add_reservation";
    console.log("buttonAction = " + buttonAction);
    console.log(courseList);
    add_reservationPanel.classList.remove("hidden_panel");
    add_reservationPanel.textContent = null;
    rightButtonPanel.textContent = null;
    
    var courseMainPanel = document.createElement("div");
    courseMainPanel.setAttribute("class", "courseListPanel box_shadow");
    
    var scheduleMainPanel = document.createElement("div");
    scheduleMainPanel.setAttribute("class", "scheduleListPanel courseListPanel box_shadow");
    
    var formMainPanel = document.createElement("div");
    formMainPanel.setAttribute("class", "createFormPanel_return");
    
    var mainPanel = document.createElement("div");
    mainPanel.setAttribute("class", "courseAndSchedulePanel");
    mainPanel.appendChild(courseMainPanel);
    mainPanel.appendChild(scheduleMainPanel);
    //mainPanel.appendChild(formMainPanel);
    add_reservationPanel.appendChild(mainPanel);
    add_reservationPanel.appendChild(formMainPanel);
    
    if(calendarData.account.type == 'hotel'){
        
        //hotel.reset();
        console.log(calendarData.account);
        console.log(calendarData.guestsList);
        
        var year = parseInt(calendarData.date.year);
        var month = parseInt(calendarData.date.month);
        
        mainPanel.removeChild(courseMainPanel);
        scheduleMainPanel.setAttribute("style", "left: 0;");
        scheduleMainPanel.setAttribute("class", "schedulePanel");
        
        var weekName = [i18n.get('Sun'), i18n.get('Mon'), i18n.get('Tue'), i18n.get('Wed'), i18n.get('Thu'), i18n.get('Fri'), i18n.get('Sat')];
	    var calendar = new Booking_App_Calendar(weekName, dateFormat, positionOfWeek, i18n);
        var dayHeight = parseInt(scheduleMainPanel.clientWidth / 7);
	    console.log("dayHeight = " + dayHeight);
        
        var datePanel = document.createElement("div");
        datePanel.setAttribute("class", "calendarData");
        datePanel.textContent = calendar.formatBookingDate(month, null, year, null, null, null);
        
        console.log(year + "/" + month);
        
        var returnLabel = document.createElement("label");
        returnLabel.setAttribute("class", "arrowLeft");
        if(month == 1){
            
            returnLabel.textContent = "＜" + calendar.formatBookingDate(12, null, null, null, null, null);
            
        }else{
            
            returnLabel.textContent = "＜" + calendar.formatBookingDate((month - 1), null, null, null, null, null);;
        
        }
        
        
        var returnPanel = document.createElement("div");
        returnPanel.setAttribute("class", "calendarChangeButton");
        returnPanel.appendChild(returnLabel);
        
        var nextLabel = document.createElement("label");
        nextLabel.setAttribute("class", "arrowRight");
        if(month == 12){
            
            nextLabel.textContent = calendar.formatBookingDate(1, null, null, null, null, null) + "＞";
            
        }else{
            
            nextLabel.textContent = calendar.formatBookingDate((month + 1), null, null, null, null, null) + "＞";
            
        }
        var nextPanel = document.createElement("div");
        nextPanel.setAttribute("style", "text-align: right;");
        nextPanel.setAttribute("class", "calendarChangeButton");
        nextPanel.appendChild(nextLabel);
        
        var topPanel = document.createElement("div");
        topPanel.setAttribute("class", "calendarPanel");
        topPanel.appendChild(returnPanel);
        topPanel.appendChild(datePanel);
        topPanel.appendChild(nextPanel);
        scheduleMainPanel.appendChild(topPanel);
        
        var calendarKey = calendar.getDateKey(month, day, year);
        var checkDate = hotel.getCheckDate();
        if(checkDate.checkIn == null && calendarData.schedule[parseInt(calendarKey)] != null && calendarData.schedule[parseInt(calendarKey)][0] != null){
            
            checkDate.checkIn = calendarData.schedule[parseInt(calendarKey)][0];
            console.log(hotel.getCheckDate());
            
        }
        
        
        var scopeOfDay = {start: null, end: null};
        var dayPanelList = {};
        calendar.create(scheduleMainPanel, calendarData, month, day, year, '', function(callback){
            
            console.log(callback);
            var key = parseInt(callback.key);
            var dayPanel = callback['eventPanel'];
            if(key > 0){
                
                dayPanelList[key] = dayPanel;
                
            }
            dayPanel.setAttribute("style", "height: " + (dayHeight / 2) + "px;");
            dayPanel.setAttribute("data-unixTime", 0);
            if(calendarData.schedule[key] != null && calendarData.schedule[key][0] != null){
                
                dayPanel.setAttribute("data-unixTime", calendarData.schedule[key][0].unixTime);
                //console.log(calendarData.schedule[key][0]);
                
                if(calendarData.schedule[key].length != 0){
                    
                    
                    if(checkDate.checkIn.unixTime <= calendarData.schedule[key][0].unixTime){
                        
                        hotel.addSchedule(calendarData.schedule[key][0]);
                        
                    }
                    
                    if(checkDate.checkIn.unixTime == calendarData.schedule[key][0].unixTime && calendarData.schedule[key][0].remainder > 0){
                        
                        dayPanel.classList.add("selectedDayPanel");
                        
                    }
                    
                    if(parseInt(calendarData.schedule[key][0].remainder) <= 0 || calendarData.schedule[key][0].stop == 'true'){
                        
                        dayPanel.classList.remove("selectedDayPanel");
                        dayPanel.classList.add("closeDay");
                        
                    }
                    
                    dayPanel.onclick = function(){
                        
                        var dateKey = parseInt(this.getAttribute("data-key"));
                        console.log("dateKey = " + dateKey);
                        var checkIn = document.getElementById("checkIn").getAttribute("data-check");
                        var checkInUnixTime = parseInt(document.getElementById("checkIn").getAttribute("data-unixTime"));
                        console.log("checkIn = " + checkIn + " checkInUnixTime = " + checkInUnixTime);
                        
                        var schedule = calendarData.schedule[dateKey][0];
                        var checkOutUnixTime = parseInt(schedule.unixTime);
                        var checkOutBool = true;
                        if(checkIn == parseInt(schedule.key)){
                            
                            return null;
                            
                        }
                        
                        var checkDate = hotel.getCheckDate();
                        var checkInUnixTime = parseInt(checkDate.checkIn.unixTime);
                        var checkInMonth = parseInt(checkDate.checkIn.month);
                        var chekInDay = parseInt(checkDate.checkIn.day);
                        var checkInYear = parseInt(checkDate.checkIn.year);
                        
                        
                        var verifySchedule = false;
                        if(checkInUnixTime < checkOutUnixTime){
                            
                            hotel.setCheckOut(schedule);
                            hotel.setCheckOutKey(schedule.key);
                            verifySchedule = hotel.verifySchedule(true);
                            console.log(verifySchedule);
                            for(var key in dayPanelList){
                                
                                var checkOut = parseInt(dayPanelList[key].getAttribute("data-unixTime"));
                                if(verifySchedule.status == true && checkInUnixTime <= checkOut && checkOutUnixTime >= checkOut){
                                    /**
                                    var stop = calendarData.schedule[key][0].stop;
                                    var remainder = parseInt(calendarData.schedule[key][0].remainder);
                                    if((remainder == 0 || stop == 'true') && parseInt(checkOut) != checkOutUnixTime){
                                        
                                        (function(){
                                            
                                            console.log("remainder = " + remainder + " stop = " + stop);
                                            for(var key in dayPanelList){
                                                
                                                var unixTime = parseInt(dayPanelList[key].getAttribute("data-unixTime"));
                                                if(checkInUnixTime != unixTime){
                                                    
                                                    dayPanelList[key].classList.remove("selectedDayPanel");
                                                    
                                                }
                                                
                                            }
                                            
                                        })();
                                        checkOutBool = false;
                                        break;
                                    }
                                    **/
                                    dayPanelList[key].classList.add("selectedDayPanel");
                                    
                                }else if(checkInUnixTime != checkOut){
                                    
                                    dayPanelList[key].classList.remove("selectedDayPanel");
                                    
                                }
                                
                            }
                            
                        }
                        
                        var checkOut = document.getElementById("checkOut");
                        if(verifySchedule.status == true){
                            
                            checkOut.setAttribute("data-check", schedule.key);
                            checkOut.textContent = calendar.formatBookingDate(schedule.month, schedule.day, schedule.year, null, null, null, schedule.weekKey);
                            hotel.setCheckOut(schedule);
                            hotel.setCheckOutKey(schedule.key);
                            
                        }else{
                            
                            hotel.setCheckOut(null);
                            hotel.setCheckOutKey(null);
                            checkOut.setAttribute("data-check", null);
                            checkOut.textContent = i18n.get("Please choose a departure date from the calendar");
                            
                        }
                        
                        hotel.verifySchedule(true);
                        
                    }
                    
                }else{
                    
                    dayPanel.classList.add("closeDay");
                    dayPanel.classList.remove("pointer");
                    
                }
                
            }else{
                
                dayPanel.classList.add("closeDay");
                dayPanel.classList.remove("pointer");
                
            }
            
        });
        
        returnLabel.onclick = function(){
            
            if(month == 1){
                
                year--;
                month = 12;
                
            }else{
                
                month--;
                
            }
            
            getReservationData(month, 1, year, accountKey, function(calendarData){
                
                console.log(calendarData);
                add_reservation(add_reservationPanel, month, parseInt(calendarData.date.lastDay), year, calendarData, accountKey, callback);
                
            });
            
        }
        
        nextLabel.onclick = function(){
            
            if(month == 12){
                
                year++;
                month = 1;
                
            }else{
                
                month++;
            
            }
            
            getReservationData(month, 1, year, accountKey, function(calendarData){
                
                console.log(calendarData);
                add_reservation(add_reservationPanel, month, 1, year, calendarData, accountKey, callback);
                
            });
            
        }
        
        createForm(mainPanel, courseMainPanel, scheduleMainPanel, formMainPanel, month, day, year, calendarData, course, null, accountKey, function(response){
            
            if(response.action == 'refresh'){
                
                callback(response)
                
            }
            
        });
        
    }else{
        
        if(courseBool == true){
            
            if(courseList.length == 0){
                
                var errorMessage = i18n.get("Service is not registered. ");
                errorMessage += i18n.get("Please create a service on the setting page.");
                var confirm = new Confirm();
                confirm.alertPanelShow(i18n.get("Error"), errorMessage, false, function(caalback){
                    
                    
                    
                });
                
                return null;
                
            }
            
            var animationBool = true;
            var coursePanelList = [];
            for(var i = 0; i < courseList.length; i++){
                
                var course = courseList[i];
                if(course.active != "true"){
                    
                    continue;
                    
                }
                
                course["status"] = true;
                
                var coursePanel = document.createElement("div");
                coursePanel.setAttribute("data-key", i);
                coursePanel.setAttribute("data-status", 1);
                coursePanel.setAttribute("class", "courseAndScheduleRow");
                
                
                var courseNamePanel = document.createElement("span");
                courseNamePanel.textContent = course["name"];
                coursePanel.appendChild(courseNamePanel);
                
                if(course.cost != null){
                    
                    var cost = formatCost(course.cost, currency);
                    var courseCostPanel = document.createElement("span");
                    courseCostPanel.classList.add("courseCostPanel");
                    courseCostPanel.textContent = cost;
                    coursePanel.appendChild(courseCostPanel);
                    
                }
                
                coursePanelList.push(coursePanel);
                
                var table_row = document.createElement("div");
                table_row.appendChild(coursePanel);
                
                courseMainPanel.appendChild(table_row);
                
                coursePanel.onclick = function(){
                    
                    this.setAttribute("class", "courseAndScheduleRow courseAndScheduleRowActive");
                    var key = this.getAttribute("data-key");
                    unselectPanel(key, coursePanelList, "courseAndScheduleRow");
                    console.log(courseList[parseInt(key)]);
                    createSchedule(mainPanel, courseMainPanel, scheduleMainPanel, formMainPanel, month, day, year, calendarData, courseList[parseInt(key)], accountKey, function(response){
                        
                        callback(response);
                        
                    });
                    
                }
                
            }
            
            coursePanelList[0].setAttribute("class", "courseAndScheduleRow courseAndScheduleRowActive");
            createSchedule(mainPanel, courseMainPanel, scheduleMainPanel, formMainPanel, month, day, year, calendarData, courseList[0], accountKey, function(response){
                
                callback(response);
                
            });
            
        }else{
            
            mainPanel.removeChild(courseMainPanel);
            scheduleMainPanel.setAttribute("style", "left: 0;");
            scheduleMainPanel.setAttribute("class", "schedulePanel");
            
            createSchedule(mainPanel, courseMainPanel, scheduleMainPanel, formMainPanel, month, day, year, calendarData, null, accountKey, function(response){
                
                callback(response);
                
            });
            
        }
        
    }
    
    
    
    
    
}

var createBookingCalendar = function(add_reservationPanel, day, calendarData, accountKey, scheduleMainPanel, callback){
    
    var year = parseInt(calendarData.date.year);
    var month = parseInt(calendarData.date.month);
    
    var weekName = [i18n.get('Sun'), i18n.get('Mon'), i18n.get('Tue'), i18n.get('Wed'), i18n.get('Thu'), i18n.get('Fri'), i18n.get('Sat')];
    var calendar = new Booking_App_Calendar(weekName, dateFormat, positionOfWeek, i18n);
    var dayHeight = parseInt(scheduleMainPanel.clientWidth / 7);
	console.log("dayHeight = " + dayHeight);
    
    var datePanel = document.createElement("div");
    datePanel.setAttribute("class", "calendarData");
    datePanel.textContent = calendar.formatBookingDate(month, null, year, null, null, null);
    
    console.log(year + "/" + month);
    
    var returnLabel = document.createElement("label");
    returnLabel.setAttribute("class", "arrowLeft");
    if(month == 1){
        
        returnLabel.textContent = "＜" + calendar.formatBookingDate(12, null, null, null, null, null);
        
    }else{
        
        returnLabel.textContent = "＜" + calendar.formatBookingDate((month - 1), null, null, null, null, null);;
    
    }
    
    
    var returnPanel = document.createElement("div");
    returnPanel.setAttribute("class", "calendarChangeButton");
    returnPanel.appendChild(returnLabel);
    
    var nextLabel = document.createElement("label");
    nextLabel.setAttribute("class", "arrowRight");
    if(month == 12){
        
        nextLabel.textContent = calendar.formatBookingDate(1, null, null, null, null, null) + "＞";
        
    }else{
        
        nextLabel.textContent = calendar.formatBookingDate((month + 1), null, null, null, null, null) + "＞";
        
    }
    var nextPanel = document.createElement("div");
    nextPanel.setAttribute("style", "text-align: right;");
    nextPanel.setAttribute("class", "calendarChangeButton");
    nextPanel.appendChild(nextLabel);
    
    var topPanel = document.createElement("div");
    topPanel.setAttribute("class", "calendarPanel");
    topPanel.appendChild(returnPanel);
    topPanel.appendChild(datePanel);
    topPanel.appendChild(nextPanel);
    scheduleMainPanel.appendChild(topPanel);
    
    var clickPoint = {start: null, end: null};
    var scopeOfDay = {start: null, end: null};
    var dayPanelList = {};
    calendar.create(scheduleMainPanel, calendarData, month, day, year, '', function(callback){
        
        console.log(callback);
        var key = parseInt(callback.day);
        var dayPanel = callback['eventPanel'];
        if(key > 0){
            
            dayPanelList[key] = dayPanel;
            
        }
        dayPanel.setAttribute("style", "height: " + (dayHeight / 2) + "px;");
        if(calendarData.schedule[key] != null && calendarData.schedule[key][0] != null){
            
            console.log(calendarData.schedule[key]);
            if(calendarData.schedule[key].length != 0){
                
                if(key == parseInt(day)){
                    
                    dayPanel.classList.add("selectedDayPanel");
                    
                }
                
                if(parseInt(calendarData.schedule[key][0].remainder) <= 0){
                    
                    dayPanel.classList.add("closeDay");
                    
                }
                
                dayPanel.onclick = function(){
                    
                    var dateKey = parseInt(this.getAttribute("data-key"));
                    console.log("dateKey = " + dateKey);
                    var checkIn = document.getElementById("checkIn").getAttribute("data-check");
                    var checkInUnixTime = parseInt(document.getElementById("checkIn").getAttribute("data-unixTime"));
                    console.log("checkIn = " + checkIn + " checkInUnixTime = " + checkInUnixTime);
                    
                    var schedule = calendarData.schedule[dateKey][0];
                    var checkOutUnixTime = parseInt(schedule.unixTime);
                    var checkOutBool = true;
                    if(checkInUnixTime < checkOutUnixTime){
                        
                        for(var key in dayPanelList){
                            
                            if(day <= parseInt(key) && dateKey >= parseInt(key)){
                                
                                var remainder = parseInt(calendarData.schedule[key][0].remainder);
                                if(remainder == 0 && parseInt(key) != dateKey){
                                    
                                    (function(){
                                        
                                        console.log("remainder = " + remainder);
                                        for(var key in dayPanelList){
                                            
                                            if(day != parseInt(key)){
                                                
                                                dayPanelList[key].classList.remove("selectedDayPanel");
                                                
                                            }
                                            
                                        }
                                        
                                    })();
                                    checkOutBool = false;
                                    break;
                                }
                                dayPanelList[key].classList.add("selectedDayPanel");
                                
                            }else{
                                
                                dayPanelList[key].classList.remove("selectedDayPanel");
                                
                            }
                            
                        }
                        
                    }
                    
                    var checkOut = document.getElementById("checkOut");
                    if(checkOutBool == true){
                        
                        checkOut.setAttribute("data-check", schedule.key);
                        checkOut.textContent = calendar.formatBookingDate(schedule.month, schedule.day, schedule.year, null, null, null, schedule.weekKey);
                        
                    }else{
                        
                        checkOut.setAttribute("data-check", null);
                        checkOut.textContent = i18n.get("Please choose a departure date from the calendar");
                        
                    }
                    
                }
                
            }else{
                
                dayPanel.classList.add("closeDay");
                dayPanel.classList.remove("pointer");
                
            }
            
        }else{
            
            dayPanel.classList.add("closeDay");
            dayPanel.classList.remove("pointer");
            
        }
        
    });
    
}

var createSchedule = function(mainPanel, courseMainPanel, scheduleMainPanel, formMainPanel, month, day, year, calendarData, course, accountKey, callback){
    
    
    var weekName = [i18n.get('Sun'), i18n.get('Mon'), i18n.get('Tue'), i18n.get('Wed'), i18n.get('Thu'), i18n.get('Fri'), i18n.get('Sat')];
    var calendar = new Booking_App_Calendar(weekName, dateFormat, positionOfWeek, i18n);
    var calendarKey = calendar.getDateKey(month, day, year);
    
    console.log("day = " + day);
    console.log(calendarData);
    console.log(course);
    day = parseInt(day);
    console.log(calendarData['schedule'][calendarKey]);
    
    scheduleMainPanel.textContent = null;
    
    var closeButton = document.createElement("button");
    closeButton.id = "closeButton";
    closeButton.textContent = i18n.get('Close');
    closeButton.setAttribute("class", "button media-button button-primary button-large media-button-insert");
    closeButton.setAttribute("style", "margin-left: 10px;");
    rightButtonPanel.textContent = null;
    rightButtonPanel.appendChild(closeButton);
    closeButton.onclick = function(){
        
        console.log("closeButton");
        rightButtonPanel.textContent = null;
        editPanelShow(false);
        
    }
    
    if(calendarData['schedule'][calendarKey].length == 0){
        
        console.error("error = schedule zero");
        var errorPanel = document.createElement("div");
        errorPanel.setAttribute("class", "noSchedule");
        errorPanel.textContent = i18n.get("No schedules");
        scheduleMainPanel.appendChild(errorPanel);
        return null;
        
    }
    
    
    
    for(var i = 0; i < calendarData['schedule'][calendarKey].length; i++){
        
        var schedule = calendarData['schedule'][calendarKey][i];
        schedule["select"] = true;
        if(parseInt(schedule["remainder"]) == 0 || schedule["stop"] == 'true'){
            
            schedule["select"] = false;
            
        }
        
    }
    
    if(course != null){
        
        var courseTime = parseInt(course["time"]);
        console.log("courseTime = " + courseTime);
        for(var i = 0; i < calendarData['schedule'][calendarKey].length; i++){
            
            var schedule = calendarData['schedule'][calendarKey][i];
            if(parseInt(schedule["remainder"]) == 0 || schedule["stop"] == 'true'){
                
                schedule["select"] = false;
                var rejectionTime = (parseInt(schedule["hour"]) * 60 + parseInt(schedule["min"])) - courseTime;
                console.log("rejectionTime = " + rejectionTime);
                
                (function(schedule, key, courseTime, rejectionTime, callback){
                    
                    console.log(key);
                    for(var i = 0; i < schedule.length; i++){
                        
                        var time = parseInt(schedule[i]["hour"]) * 60 + parseInt(schedule[i]["min"]);
                        if(time > rejectionTime && i < key){
                            
                            console.log("i = " + i + " hour = " + schedule[i]["hour"] + " min = " + schedule[i]["min"]);
                            callback(i);
                            
                        }
                        
                        if(i == key){
                            
                            console.log("i = " + i + " hour = " + schedule[i]["hour"] + " min = " + schedule[i]["min"]);
                            break;
                            
                        }
                        
                    }
                    
                })(calendarData['schedule'][calendarKey], i, courseTime, rejectionTime, function(key){
                    
                    console.log("callback key = " + key);
                    calendarData['schedule'][calendarKey][key]["select"] = false;
                    
                });
                
            }
            
        }
        
    }
    
    var scheduleListPanel = [];
    for(var i = 0; i < calendarData['schedule'][calendarKey].length; i++){
        
        var schedule = calendarData['schedule'][calendarKey][i];
        console.log(schedule);
        
        var schedulePanel = document.createElement("div");
        schedulePanel.textContent = ("0" + schedule["hour"]).slice(-2) + ":" + ("0" + schedule["min"]).slice(-2) + " " + schedule['title'];
        schedulePanel.setAttribute("data-key", i);
        scheduleListPanel.push(schedulePanel);
        
        if(schedule["select"] === true){
            
            schedulePanel.setAttribute("data-status", 1);
            schedulePanel.setAttribute("class", "courseAndScheduleRow");
            schedulePanel.onclick = function(){
                
                closeButton.setAttribute("class", "hidden_panel");
                this.setAttribute("class", "courseAndScheduleRow courseAndScheduleRowActive");
                var key = this.getAttribute("data-key");
                var schedule = calendarData['schedule'][calendarKey][key];
                unselectPanel(key, scheduleListPanel, "courseAndScheduleRow");
                createForm(mainPanel, courseMainPanel, scheduleMainPanel, formMainPanel, month, day, year, calendarData, course, schedule, accountKey, function(response){
                    
                    if(response.action == 'return'){
                        
                        closeButton.setAttribute("class", "button media-button button-primary button-large media-button-insert");
                        console.log(response.action);
                        
                    }else if(response.action == 'refresh'){
                        
                        callback(response)
                        
                    }
                    
                });
                
            }
            
        }else{
            
            schedulePanel.setAttribute("data-status", 0);
            schedulePanel.setAttribute("class", "courseAndScheduleRowError");
            
        }
        
        var table_row = document.createElement("div");
        table_row.appendChild(schedulePanel);
        
        scheduleMainPanel.appendChild(table_row);
        
    }
    
    
    
    return scheduleMainPanel;
    
}


var createForm = function(mainPanel, courseMainPanel, scheduleMainPanel, formMainPanel, month, day, year, calendarData, course, schedule, accountKey, callback){
    
    console.log("accountKey = " + accountKey);
    console.log(formData);
    console.log(day);
    console.log(calendarData);
    console.log(course);
    console.log(schedule);
    
    var input = new Input();
    formMainPanel.textContent = null;
    //buttonPanel.textContent = null;
    var children = rightButtonPanel.children;
    for(var i = children.length; i > 0; i--){
        
        if(children[i - 1].id != 'closeButton'){
            rightButtonPanel.removeChild(children[i - 1]);
        }
        
    }
    
    var returnButton = null;
    if(course != null){
        
        mainPanel.setAttribute("class", "courseAndSchedulePanel_next");
        
        returnButton = document.createElement("button");
        returnButton.id = "returnButton";
        returnButton.textContent = i18n.get('Return');
        returnButton.setAttribute("class", "button media-button button-primary button-large media-button-insert");
        returnButton.setAttribute("style", "margin-left: 10px;");
        rightButtonPanel.appendChild(returnButton);
        
        
    }else{
        
        mainPanel.setAttribute("class", "courseAndSchedulePanel_next");
        scheduleMainPanel.setAttribute("class", "schedulePanel_next");
        
    }
    
    //formMainPanel.setAttribute("class", "courseListPanel box_shadow show_panel");
    formMainPanel.setAttribute("class", "createFormPanel_show box_shadow show_panel");
    /**
    if(calendarData.account.type == "day"){
        
        formMainPanel.setAttribute("class", "createFormPanel_show box_shadow show_panel");
        
    }else{
        
        formMainPanel.setAttribute("class", "createFormPanel_show box_shadow");
        
    }
    **/
    
    var bookingButton = document.createElement("button");
    bookingButton.textContent = i18n.get('Booking');
    bookingButton.setAttribute("class", "button media-button button-primary button-large media-button-insert");
    bookingButton.setAttribute("style", "margin-left: 10px;");
    rightButtonPanel.appendChild(bookingButton);
    
    var formPanel = document.createElement("div");
    formPanel.id = "inputFormPanel";
    formMainPanel.appendChild(formPanel);
    
    var monthFull = monthFullName[parseInt(calendarData.date.month)];
    //var date = monthFull + " " + ("0" + day).slice(-2) + ", " + calendarData.date.year + " " + ("0" + schedule.hour).slice(-2) + ":" + ("0" + schedule.min).slice(-2) + " " + schedule.title;
    
    var weekName = [i18n.get('Sun'), i18n.get('Mon'), i18n.get('Tue'), i18n.get('Wed'), i18n.get('Thu'), i18n.get('Fri'), i18n.get('Sat')];
	var calendar = new Booking_App_Calendar(weekName, dateFormat, positionOfWeek, i18n);
	var calendarKey = calendar.getDateKey(month, day, year);
    
    var totalCost = 0;
    if(schedule != null){
        
        var date = calendar.formatBookingDate(calendarData.date.month, day, calendarData.date.year, schedule.hour, schedule.min, schedule.title, schedule.weekKey);
        var rowPanel = createRowPanel(i18n.get("Booking Date"), date, null, null, null);
        formPanel.appendChild(rowPanel);
        totalCost = parseInt(schedule.cost);
        
    }
    
    if(calendarData.account.type == "hotel"){
        
        formMainPanel.classList.remove("show_panel");
        //scheduleMainPanel.classList.remove("schedulePanel_next");
        scheduleMainPanel.setAttribute("style", "animation-name: unset;");
        mainPanel.setAttribute("style", "animation-name: unset;");
        var schedule = calendarData.schedule[parseInt(calendarKey)][0];
        if(hotel.getCheckDate().checkIn != null){
            
            schedule = hotel.getCheckDate().checkIn;
            
        }
        console.log(schedule);
        bookingButton.disabled = true;
        var style = null;
        var date = calendar.formatBookingDate(schedule.month, schedule.day, schedule.year, null, null, null, schedule.weekKey);
        if(schedule.remainder <= 0){
            
            style = "color: red;";
            date = i18n.get("There is no rooms to booking");
            hotel.resetCheckDate();
            
        }else if(schedule.stop == 'true'){
            
            style = "color: red;";
            date = i18n.get("The booking reception is suspended");
            hotel.resetCheckDate();
            
        }else{
            
            hotel.setCheckIn(schedule);
            hotel.setCheckInKey(schedule.key);
            
        }
        
        var checkInClear = document.createElement("label");
        checkInClear.textContent = "Clear";
        checkInClear.classList.add("change");
        
        var expressionsCheck = calendar.getExpressionsCheck(calendarData.account.expressionsCheck);
        
        var checkIn = createRowPanel(expressionsCheck.arrival, date, "checkIn", "false", null);
        formPanel.appendChild(checkIn);
        document.getElementById("checkIn").setAttribute("data-check", schedule.key);
        document.getElementById("checkIn").setAttribute("data-unixTime", schedule.unixTime);
        document.getElementById("checkIn").setAttribute("style", style);
        
        var checkOutClear = document.createElement("label");
        checkOutClear.textContent = "Clear";
        checkOutClear.classList.add("change");
        var checkOut = createRowPanel(expressionsCheck.departure, expressionsCheck.chooseDeparture, "checkOut", "true", null);
        //document.getElementById("checkOut").setAttribute("data-check", "");
        formPanel.appendChild(checkOut);
        
        var totalLengthOfStayValue = document.createElement("div");
        totalLengthOfStayValue.id = "totalLengthOfStayValue";
        totalLengthOfStayValue.textContent = 0;
        
        var totalLengthOfStay = createRowPanel(i18n.get("Total length of stay"), totalLengthOfStayValue, null, null, null);
        formPanel.appendChild(totalLengthOfStay);
        
        console.log(calendarData.guestsList);
        var guestsList = calendarData.guestsList;
        for(var key in guestsList){
            
            var list = JSON.parse(guestsList[key].json);
            console.log(list);
            var values = [];
            for(var i = 0; i < list.length; i++){
                
                values.push(list[i].name);
                
            }
            
            console.log(values);
            guestsList[key].values = values;
            guestsList[key].type = "SELECT";
            guestsList[key].value = 0;
            guestsList[key].index = 0;
            guestsList[key].person = 0;
            hotel.addGuests(key, guestsList[key]);
            if(list[0] != null){
                
                guestsList[key].person = parseInt(list[0].number);
                var response = hotel.setGuests(key, 0, list[0].number);
                
            }
            
            
            var value = input.createInput(guestsList[key]['name'], guestsList[key], {}, function(event){
                
                var key = this.parentElement.getAttribute("data-guset");
                var index = parseInt(this.selectedIndex);
                var list = JSON.parse(guestsList[key].json);
                guestsList[key].index = index;
                var response = hotel.setGuests(key, index, list[index].number);
                var feeList = hotel.getFeeList();
                hotel.pushCallback();
                //document.getElementById("totalLengthOfStayValue").textContent = response.nights;
                //document.getElementById("totalGuests").textContent = response.person;
                //document.getElementById("additionalFee").textContent = formatCost((feeList.additionalFee * response.nights), currency);
                /**
                if(response.booking == false || response.nights == 0 || response.requiredGuests == false){
                    
                    bookingButton.disabled = true;
                    
                }else{
                    
                    bookingButton.disabled = false;
                    
                }
                **/
                totalNumberOfGuests.classList.remove("errorPanel");
                if(response.booking == false){
                    
                    totalNumberOfGuests.classList.add("errorPanel");
                    
                }
                
                console.log(totalNumberOfGuests);
                
                console.log(response);
                console.log(this.selectedIndex);
                console.log(guestsList[key]);
                console.log(list[index]);
                
            });
            value.setAttribute("data-guset", key);
            var required = parseInt(guestsList[key].required);
            console.log("required = " + required);
            var rowPanel = createRowPanel(guestsList[key]['name'], value, null, required, null);
            formPanel.appendChild(rowPanel);
            
            
        }
        
        var feeList = hotel.getFeeList();
        
        var totalNumberOfGuests = createRowPanel(i18n.get("Total number of guests"), "0", "totalGuests", null, null);
        formPanel.appendChild(totalNumberOfGuests);
        /**
        var totalLengthOfStayValue = document.createElement("div");
        totalLengthOfStayValue.id = "totalLengthOfStayValue";
        totalLengthOfStayValue.textContent = 0;
        
        var totalLengthOfStay = createRowPanel(i18n.get("Total length of stay"), totalLengthOfStayValue, null, null, null);
        formPanel.appendChild(totalLengthOfStay);
        **/
        
        /**
        var additionalFee = formatCost(feeList.additionalFee, currency);
        var additionalFeePanel = createRowPanel(i18n.get("Additional fees"), additionalFee, "additionalFee", null, null);
        formPanel.appendChild(additionalFeePanel);
        **/
        
        var summaryListPanel = document.createElement("div");
        summaryListPanel.id = "summaryListPanel";
        var summaryPanel = createRowPanel(i18n.get("Summary"), summaryListPanel, "summaryPanel", null, null);
        formPanel.appendChild(summaryPanel);
        
        console.log("guestsList.length = " + guestsList.length);
        if(guestsList.length == 0){
            
            totalNumberOfGuests.classList.add("hidden_panel");
            //additionalFeePanel.classList.add("hidden_panel");
            
        }
        
        /**
        var formatPrice = formatCost(0, currency);
        var rowPanel = createRowPanel(i18n.get("Accommodation fees"), formatPrice, "bookingFee", null, null);
        formPanel.appendChild(rowPanel);
        **/
        
        var formatPrice = formatCost(0, currency);
        var rowPanel = createRowPanel(i18n.get("Total price"), formatPrice, "totalPrice", null, null);
        formPanel.appendChild(rowPanel);
        
        hotel.setCallback(function(response){
            
            console.log(response);
            var feeList = hotel.getFeeList();
            totalCost = response.amount;
            hotel.showSummary(summaryListPanel, expressionsCheck);
            var nightsValue = response.nights + " nights";
            if(response.nights == 1){
                
                nightsValue = response.nights + " night";
                
            }
            document.getElementById("totalLengthOfStayValue").textContent = nightsValue;
            
            var totalNumberOfGuestsValue = 0;
            if(response.person > 1){
                
                totalNumberOfGuestsValue = response.person + " " + i18n.get("people");
                
            }else if(response.person == 1){
                
                totalNumberOfGuestsValue = response.person + " " + i18n.get("person");
                
            }
            
            document.getElementById("totalGuests").textContent = totalNumberOfGuestsValue;
            //document.getElementById("additionalFee").textContent = formatCost((feeList.additionalFee * response.nights), currency);
            //document.getElementById("bookingFee").textContent = formatCost(totalCost, currency);
            
            var totalPrice = response.amount + (response.additionalFee * response.nights);
            document.getElementById("totalPrice").textContent = formatCost(totalPrice, currency);
            
            if(response.booking == false || response.nights == 0 || response.requiredGuests == false){
                
                bookingButton.disabled = true;
                
            }else{
                
                bookingButton.disabled = false;
                
            }
            
        });
        
    }else {
        
        if(course != null){
            
            if(course.cost != null){
                
                totalCost += parseInt(course.cost);
                
            }
            
            var rowPanel = createRowPanel(courseName, course.name, null, null, null);
            formPanel.appendChild(rowPanel);
            
        }
        
        console.log("totalCost = " + totalCost);
        if(totalCost != 0){
            
            var formatPrice = formatCost(totalCost, currency);
            var rowPanel = createRowPanel(i18n.get("Price"), formatPrice, "bookingFee", null, null);
            formPanel.appendChild(rowPanel);
            
        }
        
    }
    
    
    
    
    var formPanelList = {};
    var inputData = {};
    
    for(var i = 0; i < formData.length; i++){
        
        if(formData[i].active != 'true'){
            
            continue;
            
        }
        
        var value = input.createInput(i, formData[i], inputData, null);
        var rowPanel = createRowPanel(formData[i]['name'], value, null, formData[i].required, null);
        formPanelList[i] = rowPanel;
        
        formPanel.appendChild(rowPanel);
        
    }
    
    
    if(returnButton != null){
        
        returnButton.onclick = function(){
            
            console.log("returnButton onclick");
            if(returnButton != null){rightButtonPanel.removeChild(returnButton);}
            rightButtonPanel.removeChild(bookingButton);
            mainPanel.setAttribute("class", "courseAndSchedulePanel_return");
            //formMainPanel.setAttribute("class", "courseListPanel");
            formMainPanel.setAttribute("class", "createFormPanel_return return_panel");
            callback({action: 'return'});
            
        }
        
    }
    
    bookingButton.onclick = function(){
        
        console.log(emailEnableList);
        console.log("enable = " + Boolean(parseInt(emailEnableList.mail_new_admin.enable)));
        
        var enable = false;
        if(Boolean(parseInt(emailEnableList.mail_new_admin.enable)) === false){
            
            enable = true;
            
        }
        console.log("enable = " + enable);
        
        var confirm = new Confirm();
        confirm.dialogPanelShow(i18n.get("Confirm send email"), i18n.get("Send email notification to customer and admin about this operation?"), enable, function(sendEmail){
            
            var valueList = {};
            var post = verifyForm("sendBooking", nonce, action, calendarData.date, schedule, course, formData, formPanelList, inputData, valueList);
            post.sendEmail = Number(sendEmail);
            if(post !== false){
                
                post.accountKey = accountKey;
                if(calendarData.account.type == "hotel"){
                    
                    post.json = JSON.stringify(hotel.verifySchedule(true));
                    
                }
                loadingPanel.setAttribute("class", "loading_modal_backdrop");
                xmlHttp = new Booking_App_XMLHttp(url, post, function(response){
                    
                    console.log(response);
                    if(response.status == "success"){
                        
                        hotel.reset();
                        hotel.setCallback(null);
                        rightButtonPanel.textContent = null;
                        response.action = 'refresh';
                        buttonAction = "reservation_users";
                        createCalendar(response, response.date.month, response.date.day, response.date.year, accountKey);
                        callback(response);
                        
                    }else{
                        
                        alert(response.message);
                        
                    }
                    loadingPanel.setAttribute("class", "hidden_panel");
                    
                });
                
            }
            
        });
        
    }
    
}

var verifyCalendar = function(mode, month, day, year, lastDay){
    
    var calendarChange = 0;
    if(mode == 0){
    
        day--;
        if(day == 0){
            
            calendarChange = 1;
            month--;
            day = 1;
            if(month == 0){
                month = 12;
                year--;
            }
            
        }
        
    }else if(mode == 1){
        
        day++;
        if(day > lastDay){
            
            calendarChange = 1;
            month++;
            day = 1;
            if(month == 13){
                month = 1;
                year++;
            }
            
        }
        
    }
    
    var date = {month: month, day: day, year: year, calendarChange: calendarChange};
    return date;
    
}

var verifyForm = function(mode, nonce, action, date, schedule, course, formData, formPanelList, inputData, valueList){
    
    console.log(date);
    console.log(schedule);
    console.log(course);
    var sendBool = true;
    var input = new Input();
    for(var key in formData){
        
        console.log(key);
        console.log(inputData[key]);
        console.log(formData[key]);
        
        if(formData[key].active != 'true'){
            
            continue;
            
        }
        
        if(formPanelList[key] == null){
            
            continue;
            
        }
        
        var bool = input.inputCheck(key, formData[key], inputData[key], valueList);
        console.log("bool = " + bool);
        if(bool === true){
            
            formPanelList[key].removeAttribute("data-errorInput");
            formPanelList[key].classList.remove("rowError");
            //formPanelList[key].setAttribute("class", "row");
            
        }else{
            
            sendBool = false;
            formPanelList[key].setAttribute("data-errorInput", 1);
            formPanelList[key].classList.add("rowError");
            //formPanelList[key].setAttribute("class", "row rowError");
            
        }
        
    }
    
    console.log(valueList);
    if(sendBool === true){
        
        //schedule
        var post = {nonce: nonce, action: action, mode: mode, month: date.month, day: 1, year: date.year, applicantCount: '1', permission: 'public', timeKey: schedule.key, unixTime: schedule.unixTime};
        if(course != null){
            
            post.courseKey = course.key;
            
        }
        
        for(var key in valueList){
            
            console.log(valueList[key]);
            post['form' + key] = valueList[key].join(",");
            
        }
        
        return post;
        
    }else{
        
        return false;
        
    }
    
}

var unselectPanel = function(selectedKey, panelList, styleName){
    
    for(var i = 0; i < panelList.length; i++){
        
        var key = panelList[i].getAttribute("data-key");
        var status = parseInt(panelList[i].getAttribute("data-status"));
        if(key != selectedKey && status === 1){
            
            panelList[i].setAttribute("class", styleName);
            
        }
        
        
    }
    
}

var createRowPanel = function(name, value, id, required, actionElement){
    
    var namePanel = document.createElement("div");
    namePanel.setAttribute("class", "name");
    namePanel.textContent = name;
    //console.log("typeof required = " + typeof required);
    if((typeof required == "string" && required == 'true') || (typeof required == "number" && required == 1)){
        
        namePanel.setAttribute("class", "name required");
        
    }
    
    var inputPanel = null;
    if(typeof value == 'string'){
        
        inputPanel = document.createElement("div");
        inputPanel.textContent = value;
        if(id != null){
            
            inputPanel.id = id;
            
        }
        
    }else{
        
        inputPanel = value;
        
    }
    inputPanel.setAttribute("class", "value");
    
    var rowPanel = document.createElement("div");
    rowPanel.setAttribute("class", "row");
    rowPanel.appendChild(namePanel);
    if(actionElement != null){
        
        rowPanel.appendChild(actionElement);
        
    }
    rowPanel.appendChild(inputPanel);
    
    return rowPanel;
    
}

var editPanelShow = function(showBool){
    
    var body = document.getElementsByTagName("body")[0];
    console.log(body);
    
    
    if(showBool == true){
        
        body.classList.add("modal-open");
        editPanel.setAttribute("class", "edit_modal");
        blockPanel.setAttribute("class", "edit_modal_backdrop");
        
    }else{
        
        if(document.getElementById("userInfoPanel") != null){
            
            document.getElementById("userInfoPanel").setAttribute("class", "hidden_panel");
            
        }
        
        if(document.getElementById("changePanel") != null){
            
            document.getElementById("changePanel").setAttribute("class", "hidden_panel");
            
        }
        
        if(contentPanel != null && document.getElementById("showUserInfo_blockPanel") != null){
            
            contentPanel.removeChild(document.getElementById("showUserInfo_blockPanel"));
            
        }
        
        body.classList.remove("modal-open");
        editPanel.setAttribute("class", "hidden_panel");
        blockPanel.setAttribute("class", "hidden_panel");
        
    }
    
}

var formatCost = function(cost, currency){
    
    var format = function(cost){
        
        cost = String(cost).replace(/(\d)(?=(\d\d\d)+(?!\d))/g, '$1,');
        return cost;
        
    }
    
    if(currency.toLocaleUpperCase() == 'USD'){
        
        cost = Number(cost) / 100;
        cost = cost.toFixed(2);
        //cost = new Intl.NumberFormat('en-IN').format(cost);
        cost = format(cost);
        cost = "US$" + cost;
        
    }else if(currency.toLocaleUpperCase() == "EUR"){
        
        cost = Number(cost) / 100;
        cost = cost.toFixed(2);
        //cost = new Intl.NumberFormat('en-IN').format(cost);
        cost = format(cost);
        cost = "€" + cost;
        
    }else if(currency.toLocaleUpperCase() == 'JPY'){
        
        //cost = new Intl.NumberFormat('en-IN').format(cost);
        cost = format(cost);
        cost = "¥" + cost;
        
    }else if(currency.toLocaleUpperCase() == 'KR'){
        
        cost = Number(cost) / 100;
        cost = cost.toFixed(2);
        cost = format(cost) + "kr";
        
    }
    
    console.log("cost = " + cost);
    return cost;
    
}

var setSelectedKey = function(_selectedKey){
    
    selectedKey = _selectedKey;
    
}

var getSelectedKey = function(){
    
    return selectedKey;
    
}

var setVisitors = function(_visitors){
    
    visitors = _visitors;
    
}

var getVisitors = function(){
    
    return visitors;
    
}