
var setting_data = setting_data;
const url = setting_data['url'];
const nonce = setting_data['nonce'];
const action = setting_data['action'];
var settingList = setting_data['list'];
var bookingSyncList = setting_data['bookingSyncList'];
var upgradeData = {url: setting_data['url'], nonce: setting_data['nonce'], action: setting_data['action'], locale: setting_data.locale};
var xmlHttp = null;
var i18n = null;

var blockPanel = null;
var editPanel = null;
var loadingPanel = null;

window.onload = function(){
	
	i18n = new I18n(setting_data.locale);
    i18n.setDictionary(booking_package_dictionary);
    
    blockPanel = document.getElementById("blockPanel");
    editPanel = document.getElementById("editPanel");
    //editPanel.classList.add("hidden_panel");
    loadingPanel = document.getElementById("loadingPanel");
    
    loadTabFrame();
    
    blockPanel.onclick = function(){
        
        editPanelShow(false);
        
    }
    
    document.getElementById("media_modal_close").onclick = function(){
        
        editPanelShow(false);
        
    }
    
}

function loadTabFrame(){
	
	createSettingPanel();
	
	var menuList = {settingLink: 'settingPanel', /**formLink: 'formPanel', courseLink: 'coursePanel', emailLink: 'emailPanel',**/ syncLink: "syncPanel", subscriptionLink: 'subscriptionPanel'};
	for(var key in menuList){
		
		var button = document.getElementById(key);
		button.setAttribute("data-key", key);
		button.onclick = function(event){
			
			var clickKey = this.getAttribute("data-key");
			console.log(clickKey);
			for(var key in menuList){
				
				var link = document.getElementById(key);
				var panel = document.getElementById(menuList[key]);
				if(clickKey == key){
					
					link.setAttribute("class", "menuItem active");
					panel.setAttribute("class", "");
					
					if(clickKey == 'formLink'){
						
						createFormPanel();
						
					}else if(clickKey == 'courseLink'){
						
						createCoursePanel();
						
					}else if(clickKey == 'emailLink'){
						
						emailSettingPanel();
						
					}else if(clickKey == 'subscriptionLink'){
						
						subscriptionDiteilPanel();
						
					}else if(clickKey == 'syncLink'){
						
						syncPanel();
						
					}
					
				}else{
					
					link.setAttribute("class", "menuItem");
					panel.setAttribute("class", "hidden_panel");
					
				}
				
			}
			
		}
		
	}
	
}



function subscriptionDiteilPanel(){
	
	//var upgrade = new Upgrade();
	
	var subscriptionData = {
		customer_id_for_subscriptions: setting_data.customer_id_for_subscriptions,
		id_for_subscriptions: setting_data.id_for_subscriptions,
		invoice_id_for_subscriptions: setting_data.invoice_id_for_subscriptions,
		expiration_date_for_subscriptions: setting_data.expiration_date_for_subscriptions,
		expiration_date: setting_data.expiration_date,
		customer_email_for_subscriptions: setting_data.customer_email_for_subscriptions
	};
	
	var nameList = {
		customer_id_for_subscriptions: i18n.get("ID"),
		id_for_subscriptions: i18n.get("Subscriptions ID"),
		invoice_id_for_subscriptions: i18n.get("Invoice ID"),
		expiration_date: i18n.get("Expiration date"),
		customer_email_for_subscriptions: i18n.get("Customers email")
	};
	console.log(subscriptionData);
	
	var subscriptionPanel = document.getElementById("subscriptionPanel");
	subscriptionPanel.textContent = null;
	
	var table = document.createElement("table");
	table.setAttribute("class", "emails_table table_option wp-list-table widefat fixed striped")
	subscriptionPanel.appendChild(table);
	
	for(var key in nameList){
		
		var nameTh = document.createElement("th");
		nameTh.textContent = nameList[key];
		
		var valueTd = document.createElement("td");
		valueTd.textContent = subscriptionData[key];
		
		var tr = document.createElement("tr");
		tr.appendChild(nameTh);
		tr.appendChild(valueTd);
		table.appendChild(tr);
		
	}
	
	var cancelSubscription = document.createElement("div");
	cancelSubscription.classList.add("cancelSubscription");
	cancelSubscription.textContent = i18n.get("Cancel subscription");
	subscriptionPanel.appendChild(cancelSubscription);
	
	cancelSubscription.onclick = function(event){
		
		console.log(subscriptionData);
		
		var confirm = new Confirm();
		confirm.dialogPanelShow(i18n.get("Confirm to cancel"), i18n.get("Do you really cancel the subscription?"), false, function(response){
			
			console.log(response);
			if(response === true){
				
				loadingPanel.setAttribute("class", "loading_modal_backdrop");
				var extension_url = setting_data.extension_url + "cancelSubscription/";
				console.log("extension_url = " + extension_url);
				var postData = {customer_id: subscriptionData.customer_id_for_subscriptions, subscriptions_id: subscriptionData.id_for_subscriptions};
				var xmlHttp = new Booking_App_XMLHttp(extension_url, postData, function(json){
					
					console.log(json);
					if(json["status"] == "success"){
						
						var postData = {mode: "upgradePlan", type: "delete", nonce: nonce, action: action};
    					xmlHttp = new Booking_App_XMLHttp(url, postData, function(json){
							
							if(json['status'] != 'error'){
								
								subscriptionDiteilPanel();
								
							}
							loadingPanel.setAttribute("class", "hidden_panel");
								
						});
						
					}
					
				});
				
			}
			
		});
		
	}
	
	
}

function emailSettingPanel(){
	
	
	var emailMessageList = setting_data['emailMessageList'];
	console.log(emailMessageList);
	var mailSettingPanel = document.getElementById("mailSettingPanel");
	var content_area = document.getElementById("content_area");
	content_area.textContent = null;
	
	var table = document.createElement("table");
	table.setAttribute("class", "emails_table table_option wp-list-table widefat fixed striped")
	content_area.appendChild(table);
	
	var mail_message = {mailAdmin: "mail_new_admin", mailVisitor: "mail_new_visitor", mailApproved: "mail_approved", mailPending: "mail_pending", mailDeleted: "mail_deleted"};
	var valueTdList = {};
	for(var id in mail_message){
		
		var mailMessageData = emailMessageList[mail_message[id]];
		console.log(mailMessageData);
		
		var nameTh = document.createElement("th");
		nameTh.textContent = i18n.get(mailMessageData.title);
		if(parseInt(mailMessageData.enable) === 0){
			
			nameTh.classList.add("disableTh");
			
		}
		
		var subjectLabel = document.createElement("div");
		subjectLabel.setAttribute("class", "subjectLabel");
		subjectLabel.innerHTML = "<strong>" + i18n.get("Subject") + "</strong><br>" + mailMessageData.subject;
		
		var content = mailMessageData.content.replace(/\\/g, "");
		var contentLabel = document.createElement("div");
		contentLabel.innerHTML = "<strong>" + i18n.get("Content") + "</strong><br>" + content;
		
		var valueTd = document.createElement("td");
		valueTd.appendChild(subjectLabel);
		valueTd.appendChild(contentLabel);
		//valueTd.innerHTML = mailMessageData.content.replace(/\\/g, "");
		
		var editButton = document.createElement("button");
		editButton.id = id;
		editButton.setAttribute("class", "w3tc-button-save button-primary");
		editButton.textContent = i18n.get("Edit");
		
		var editButtonTd = document.createElement("td");
		editButtonTd.setAttribute("class", "editButtonTd");
		editButtonTd.appendChild(editButton);
		
		var tr = document.createElement("tr");
		tr.appendChild(nameTh);
		tr.appendChild(valueTd);
		tr.appendChild(editButtonTd);
		
		table.appendChild(tr);
		valueTdList[id] = valueTd;
		
		editButton.onclick = function(){
			
			var id = mail_message[this.id];
			var editer_id = "textarea";
			var mailMessageData = emailMessageList[id];
			console.log("id = " + id);
			console.log(mailMessageData);
			/**
			var observer = new MutationObserver((mutations) => {
            	mutations.forEach((mutation) => {
                	
                	console.log(mutation.target);
                	
            	});
			});
        	
        	var observeConfig = { attributes: false, childList: true, characterData: true, subtree: true};
        	observer.observe(document.getElementById(id + "_panel"), observeConfig);
			**/
			document.getElementById("edit_title").textContent = mailMessageData.title;
			
			var enableCheck = document.getElementById("mailEnable");
			enableCheck.checked = false;
			if(parseInt(mailMessageData.enable) == 1){
				
				enableCheck.checked = true;
				
			}
			
			document.getElementById("emailFormatHtml").checked = true;
			if(mailMessageData.format == "text"){
				
				document.getElementById("emailFormatText").checked = true;
				
			}
			
			var subject_filed = document.getElementById("subject");
			subject_filed.setAttribute("placeholder", "Enter subject here");
			subject_filed.value = mailMessageData.subject;
			
			var mail_message_area_left = document.getElementById("mail_message_area_left");
			for(var key in mail_message){
				
				var content_id = mail_message[key];
				var content_panel = document.getElementById(content_id + "_panel");
				if(id == content_id){
					
					content_panel.classList.remove("hidden_panel");
					
				}else{
					
					content_panel.classList.add("hidden_panel");
					
				}
				
			}
			
			var mail_message_area_right = document.getElementById("mail_message_area_right");
			mail_message_area_right.textContent = null;
			
			var mail_message_area_right_title = document.createElement("div");
			mail_message_area_right_title.setAttribute("class", "mail_message_area_right_title");
			mail_message_area_right_title.textContent = i18n.get("Help");
			mail_message_area_right.appendChild(mail_message_area_right_title);
			
			var str = i18n.get("You can use following shortcodes in content editer.");
			var help_message_label = document.createElement("div");
			help_message_label.setAttribute("class", "help_message_label");
			help_message_label.textContent = str;
			mail_message_area_right.appendChild(help_message_label);
			
			var shortcodes = {id: "Booking ID", date: "Booking date", site_name: "Your site name", service: "Service"};
			for(var key in shortcodes){
				
				var formFiledPanel = document.createElement("div");
				formFiledPanel.setAttribute("class", "formFiledPanel");
				mail_message_area_right.appendChild(formFiledPanel);
				
				var codeLabel = document.createElement("div");
				codeLabel.innerHTML = "[" + key + "] is inserting \"" + shortcodes[key] + "\"";
				formFiledPanel.appendChild(codeLabel);
				
			}
			
			var formData = setting_data.formData;
			for(var i = 0; i < formData.length; i++){
				
				var filedData = formData[i];
				if(filedData.active != 'true'){
					
					continue;
					
				}
				
				var formFiledPanel = document.createElement("div");
				formFiledPanel.setAttribute("class", "formFiledPanel");
				mail_message_area_right.appendChild(formFiledPanel);
				
				var codeLabel = document.createElement("div");
				codeLabel.innerHTML = "[" + filedData.id + "] is inserting \"" + filedData.name + "\"";
				formFiledPanel.appendChild(codeLabel);
				
				
			}
			
			
			var editPanel = document.getElementById("editPanel");
			
			var media_frame_content = document.getElementById("media_frame_content");
			
			console.log(tinymce);
			console.log(tinyMCEPreInit.mceInit);
			
			editPanelShow(true);
			document.getElementById("mail_message_save_button").removeEventListener("click", event);
			document.getElementById("mail_message_save_button").onclick = function(){
				
				var value = document.getElementById(id).value;
    			console.log(value);
    			
    			if(tinymce.get(id) != null && tinymce.get(id).getContent() != null){
    				
    				value = tinymce.get(id).save();
    				console.log(tinymce.get(id));
    				console.log(tinymce.get(id).save());
    				
    			}
    			
    			var enable = 0;
    			if(enableCheck.checked === true){
    				
    				enable = 1;
    				
    			}
    			
    			var format = "html";
    			if(document.getElementById("emailFormatText").checked === true){
    				
    				format = "text";
    				
    			}
    			
    			loadingPanel.setAttribute("class", "loading_modal_backdrop");
    			var postData = {mode: "updataEmailMessage", nonce: nonce, action: action, key: mailMessageData.key, subject: subject_filed.value, content: value, enable: enable, format: format};
    			xmlHttp = new Booking_App_XMLHttp(url, postData, function(json){
					
					setting_data['emailMessageList'] = json;
					emailSettingPanel();
					loadingPanel.setAttribute("class", "hidden_panel");
					
				});
				
			}
			
			
		}
		
		
	}
	
	
	
}

function createFormPanel(){
	
	var editBool = true;
	
	var addButton = document.createElement("button");
	addButton.disabled = false;
	addButton.setAttribute("class", "w3tc-button-save button-primary");
	addButton.textContent = i18n.get("Add filed");
	
	var saveButton = document.createElement("button");
	saveButton.disabled = true;
	saveButton.setAttribute("class", "w3tc-button-save button-primary");
	saveButton.setAttribute("style", "float: right;");
	saveButton.textContent = i18n.get("Change ranking");
	
	var buttonPanel = document.createElement("div");
	buttonPanel.setAttribute("style", "padding-bottom: 10px;");
	buttonPanel.appendChild(addButton);
	buttonPanel.appendChild(saveButton);
	
	var formDataList = setting_data['formData'];
	console.log(formDataList);
	
	var mainPanel = document.getElementById("formPanel");
	mainPanel.textContent = null;
	mainPanel.appendChild(buttonPanel);
	var panel = document.createElement("div");
	panel.id = "formSort";
	panel.setAttribute("class", "dnd");
	
	var buttons = {};
	var columns = {};
	var list = {name: 'Name', email: 'Email', zip: 'Zip', D: 'D'};
	//for(var key in list){
	for(var key = 0; key < formDataList.length; key++){
		
		var contentPanel = document.createElement("div");
		contentPanel.setAttribute("class", "dnd_content");
		contentPanel.textContent = formDataList[key]['name'];
		
		if(formDataList[key]["active"] != "true"){
			
			contentPanel.classList.add("dnd_content_unactive");
			
		}
		
		var editLabel = document.createElement("label");
		editLabel.setAttribute("class", "dnd_edit");
		editLabel.setAttribute("data-key", key);
		editLabel.textContent = i18n.get("Edit");
		
		var deleteLabel = document.createElement("label");
		deleteLabel.setAttribute("class", "dnd_delete");
		deleteLabel.setAttribute("data-key", key);
		deleteLabel.textContent = i18n.get("Delete");
		
		var optionPanel = document.createElement("div");
		optionPanel.setAttribute("class", "dnd_optionBox");
		optionPanel.appendChild(editLabel);
		optionPanel.appendChild(deleteLabel);
		
		
		var column = document.createElement("div");
		column.setAttribute("class", "dnd_column");
		//column.setAttribute("draggable", "true");
		column.setAttribute("data-key", key);
		columns[key] = column;
		column.appendChild(contentPanel);
		column.appendChild(optionPanel);
		
		panel.appendChild(column);
		
		editLabel.onclick = function(event){
			
			if(editBool === true){
				
				editBool = false;
				var key = this.getAttribute("data-key");
				console.log(formDataList[key]);
				jQuery('#formSort').sortable('disable');
				editItem(columns, key, mainPanel, panel, 'updateForm', formDataList[key], setting_data['formInputType'], function(action){
					
					editBool = true;
					if(action == 'cancel'){
						
						jQuery('#formSort').sortable('enable');
						
					}else{
						
						setting_data['formData'] = action;
						createFormPanel();
						
					}
					
				});
				
			}
			
			
			
		}
		
		deleteLabel.onclick = function(event){
			
			if(editBool === true){
				
				editBool = false;
				var dataKey = parseInt(this.getAttribute("data-key"));
				var result = confirm(i18n.get('Do you delete filed of "%s"?', [formDataList[dataKey].name]));
				if(result === true){
					
					deleteItem(dataKey, "deleteFormItem", function(json){
						
						setting_data['formData'] = json;
						createFormPanel();
						
					});
					
				}
				editBool = true;
				
			}
			
		}
		
	}
	
	mainPanel.appendChild(panel);
	
	jQuery('#formSort').sortable({
									cursor: 'move',
									opacity: 0.7,
									placeholder: "ui-state-highlight",
									forcePlaceholderSize: true,
									forceHelperSize: true,
									axis: 'y'
	});
	
	jQuery(document).off("sortstop", "#formSort");
	jQuery(document).on('sortstop', '#formSort', function(){
		
		var sortBool = sortData('name', 'dnd_column', formDataList, panel, 'changeFormRank');
		if(sortBool === true){
			
			saveButton.disabled = false;
			
		}else{
			
			saveButton.disabled = true;
			
		}
		
	});
	
	addButton.onclick = function(event){
		
		if(editBool === true){
			
			editBool = false;
			jQuery('#formSort').sortable('disable');
			addButton.disabled = true;
			addItem(mainPanel, 'addForm', setting_data['formInputType'], function(action){
				
				editBool = true;
				if(action == "close"){
					
					jQuery('#formSort').sortable('enable');
					addButton.disabled = false;
					
				}else{
					
					console.log(typeof action);
					if(typeof action == 'object'){
						
						if(action['status'] != 'error'){
							
							console.log(action);
							setting_data['formData'] = action;
							createFormPanel();
							
						}
						
					}
					
				}
				
			});
			
		}
		
	}
	
	saveButton.onclick = function(event){
		
		formDataList = changeRank('name', 'dnd_column', formDataList, panel, 'changeFormRank', function(json){
			
			setting_data['formData'] = json;
			saveButton.disabled = true;
			var panelList = panel.getElementsByClassName('dnd_column');
			for(var i = 0; i < panelList.length; i++){
				
				panelList[i].setAttribute("data-key", i);
				
			}
			
		});
		
		console.log(formDataList);
		
	}
	
	
}

function createCoursePanel(){
	
	var editBool = true;
	
	var addButton = document.createElement("button");
	addButton.disabled = false;
	addButton.setAttribute("class", "w3tc-button-save button-primary");
	addButton.textContent = i18n.get("Add service");
	
	var saveButton = document.createElement("button");
	saveButton.disabled = true;
	saveButton.setAttribute("class", "w3tc-button-save button-primary");
	saveButton.setAttribute("style", "float: right;");
	saveButton.textContent = i18n.get("Change ranking");
	
	var buttonPanel = document.createElement("div");
	buttonPanel.setAttribute("style", "padding-bottom: 10px;");
	buttonPanel.appendChild(addButton);
	buttonPanel.appendChild(saveButton);
	
	var mainPanel = document.getElementById("coursePanel");
	mainPanel.textContent = null;
	mainPanel.appendChild(buttonPanel);
	
	var panel = document.createElement("div");
	panel.id = "courseSort";
	panel.setAttribute("class", "dnd");
	var buttons = {};
	var columns = {};
	var list = {name: 'Name', email: 'Email', zip: 'Zip', D: 'D', Test: 'Test', planA: 'plan A', area: 'area', G: 'G'};
	list = {};
	var courseList = setting_data['courseList'];
	console.log(courseList);
	for(var i = 0; i < courseList.length; i++){
		
		list[courseList[i]['key']] = courseList[i]['name'];
		
	}
	console.log(list);
	//for(var key in courseList){
	for(var key = 0; key < courseList.length; key++){
		
		var contentPanel = document.createElement("div");
		contentPanel.setAttribute("class", "dnd_content");
		contentPanel.textContent = courseList[key]['name'];
		
		if(courseList[key]["active"] != "true"){
			
			contentPanel.classList.add("dnd_content_unactive");
			
		}
		
		var editLabel = document.createElement("label");
		editLabel.setAttribute("class", "dnd_edit");
		editLabel.setAttribute("data-key", key);
		editLabel.textContent = i18n.get("Edit");
		
		var deleteLabel = document.createElement("label");
		deleteLabel.setAttribute("class", "dnd_delete");
		deleteLabel.setAttribute("data-key", key);
		deleteLabel.textContent = i18n.get("Delete");
		
		var optionPanel = document.createElement("div");
		optionPanel.setAttribute("class", "dnd_optionBox");
		optionPanel.appendChild(editLabel);
		optionPanel.appendChild(deleteLabel);
		
		
		var column = document.createElement("div");
		column.setAttribute("class", "dnd_column");
		column.setAttribute("draggable", "true");
		column.setAttribute("data-key", key);
		column.appendChild(contentPanel);
		column.appendChild(optionPanel);
		columns[key] = column;
		
		panel.appendChild(column);
		
		editLabel.onclick = function(event){
			
			if(editBool === true){
				
				editBool = false;
				var key = this.getAttribute("data-key");
				editItem(columns, key, mainPanel, panel, 'updateCourse', courseList[key], setting_data['courseData'], function(action){
					
					editBool = true;
					if(action == 'cancel'){
						
						
					}else{
						
						setting_data['courseList'] = action;
						createCoursePanel();
						
					}
					
				});
				
			}
			
		}
		
		deleteLabel.onclick = function(event){
			
			if(editBool === true){
				
				editBool = false;
				var courseInfo = courseList[parseInt(this.getAttribute("data-key"))];
				//var result = confirm("Do you delete service of \"" + courseInfo.name + "\"?");
				var result = confirm(i18n.get('Do you delete service of "%s"?', [courseInfo.name]));
				if(result === true){
					
					console.log(courseInfo);
					deleteItem(courseInfo.key, "deleteCourse", function(json){
						
						setting_data['courseList'] = json;
						createCoursePanel();
						
					});
					
				}
				editBool = true;
				
			}
			
		}
		
	}
	
	mainPanel.appendChild(panel);
	
	jQuery('#courseSort').sortable({
									cursor: 'move',                     //移動中のカーソル
									opacity: 0.7,                       //移動中の項目の透明度
									placeholder: "ui-state-highlight",  //ドロップ先の色指定(Styleで指定可能)
									forcePlaceholderSize: true,          //trueでドラッグした要素のサイズを自動取得できる
									forceHelperSize: true,
									axis: 'y'
	});
	
	//$( '#formSort' ).disableSelection();
	jQuery(document).off("sortstop", "#courseSort");
	jQuery(document).on('sortstop', '#courseSort', function(){
		
		var sortBool = sortData('key', 'dnd_column', courseList, panel, 'changeCourseRank');
		if(sortBool === true){
			
			saveButton.disabled = false;
			
		}else{
			
			saveButton.disabled = true;
			
		}
		
	});
	
	addButton.onclick = function(event){
		
		if(editBool === true){
			
			editBool = false;
			addButton.disabled = true;
			addItem(mainPanel, 'addCourse', setting_data['courseData'], function(action){
				
				editBool = true;
				if(action == "close"){
					
					addButton.disabled = false;
					
				}else{
					
					console.log(typeof action);
					if(typeof action == 'object'){
						
						if(action['status'] != 'error'){
							
							console.log(action);
							setting_data['courseList'] = action;
							createCoursePanel();
							
						}
						
					}
					
				}
				
			});
			
		}
		
		
	};
	
	saveButton.onclick = function(event){
		
		courseList = changeRank('key', 'dnd_column', courseList, panel, 'changeCourseRank', function(json){
			
			setting_data['courseList'] = json;
			saveButton.disabled = true;
			var panelList = panel.getElementsByClassName('dnd_column');
			for(var i = 0; i < panelList.length; i++){
				
				panelList[i].setAttribute("data-key", i);
				
			}
			
		});
		
		console.log(courseList);
		
	}
	
	/**
	console.log("height = " + height);
	panel.style.height = height + "px";
	**/
	
	
	
	
}



function addItem(mainPanel, mode, inputTypeList, callback){
	
	console.log(mainPanel);
	
	var closeHeghit = mainPanel.clientHeight;
	var addPanel = document.createElement("div");
	addPanel.id = "addCoursePanel";
	mainPanel.appendChild(addPanel);
	
    for(var key in inputTypeList){
    	
    	inputTypeList[key]['value'] = "";
    	
    }
    
    console.log(inputTypeList);
    
    if(mode == 'addCourse'){
    	
    	var courseTimeList = {};
    	for(var i = 5; i < 1440; i += 5){
    		
    		courseTimeList[i] = i + "min";
    		
    	}
    	inputTypeList['time']['valueList'] = courseTimeList;
    	
    }else if(mode == 'addForm'){
    	
    	for(var key in inputTypeList){
    		
    		if(key == "required" || key == "isEmail" || key == "isName" || key == "isAddress"){
    			
    			inputTypeList[key]['value'] = "false";
    			
    		}else if(key == "type"){
    			
    			inputTypeList[key]['value'] = "TEXT";
    			
    		}
    		
    		
    	}
    	
    }
    
	console.log(inputTypeList);
	var inputData = {};
	var table = document.createElement("table");
	table.setAttribute("class", "form-table");
	var trList = {};
	for(var key in inputTypeList){
		
		console.log(key);
        var data = inputTypeList[key];
        
        var th = document.createElement("th");
        th.setAttribute("scope", "row");
        th.textContent = i18n.get(inputTypeList[key].name);
        
        var inputPanel = createInput(key, data, inputData, false, false);
        var td = document.createElement("td");
        td.appendChild(inputPanel);
        
        var tr = document.createElement("tr");
        tr.setAttribute("valign", "top");
        tr.appendChild(th);
        tr.appendChild(td);
        trList[key] = tr;
        table.appendChild(tr);
		
	}
    
    addPanel.appendChild(table);
    
    var cancelButton = document.createElement("button");
    cancelButton.setAttribute("style", "margin-right: 10px;");
    cancelButton.textContent = i18n.get("Cancel");
    cancelButton.setAttribute("class", "w3tc-button-save button-primary");
    
    var saveButton = document.createElement("button");
    saveButton.textContent = i18n.get("Save");
    saveButton.setAttribute("class", "w3tc-button-save button-primary");
    
    var buttonPanel = document.createElement("div");
    buttonPanel.setAttribute("style", "text-align: right; margin: 10px 10px 10px 0px;");
    buttonPanel.appendChild(cancelButton);
    buttonPanel.appendChild(saveButton);
    addPanel.appendChild(buttonPanel);
    
    
    //mainPanel.style.height = closeHeghit + addPanel.clientHeight + "px";
    
    console.log("top = " + addPanel.offsetTop);
    console.log("closeHeghit = " + closeHeghit);
	window.scrollTo(0, addPanel.offsetTop);
    
    cancelButton.onclick = function(event){
    	
    	mainPanel.removeChild(addPanel);
    	mainPanel.style.height = null;
    	console.log("cancelButton closeHeghit = " + closeHeghit);
    	callback("close");
    	
    }
    
    saveButton.onclick = function(event){
    	
    	var response = null;
    	
    	var postData = {mode: mode, nonce: nonce, action: action};
    	if(mode == 'addCourse'){
    		/**
    		var selected = inputData['time']['selectBox'].selectedIndex + 1;
    		postData['name'] = inputData['name']['textBox'].value;
    		postData['time'] = selected * 5;
    		**/
    		console.log("rank = " + (document.getElementById("courseSort").childNodes.length + 1));
    		postData['rank'] = document.getElementById("courseSort").childNodes.length + 1;
    		
    		response = getInputData(inputTypeList, inputData);
    		/**
    		for(var key in response){
    			
    			if(typeof response[key] == 'boolean'){
    				
    				console.log("error key = " + key + " bool = " + response[key]);
    				post = false;
    				return null;
    				
    			}else{
    				
    				postData[key] = response[key];
    				
    			}
    			
    		}
    		**/
    		
    	}else if(mode == 'addForm'){
    		
    		response = getInputData(inputTypeList, inputData);
    		/**
    		for(var key in response){
    			
    			if(typeof response[key] == 'boolean'){
    				
    				console.log("error key = " + key + " bool = " + response[key]);
    				post = false;
    				return null;
    				
    			}else{
    				
    				postData[key] = response[key];
    				
    			}
    			
    		}
    		**/
    		
    	}
    	
    	var post = true;
    	for(var key in response){
    			
    		if(typeof response[key] == 'boolean'){
    			
    			console.log("error key = " + key + " bool = " + response[key]);
    			trList[key].classList.add("errorPanel");
    			post = false;
    			
    		}else{
    			
    			postData[key] = response[key];
    			trList[key].classList.remove("errorPanel");
    			
    		}
    		
    	}
    	
    	if(post === true){
    		
    		console.log(postData);
    		loadingPanel.setAttribute("class", "loading_modal_backdrop");
    		xmlHttp = new Booking_App_XMLHttp(url, postData, function(json){
				
				if(json['status'] != 'error'){
					
					mainPanel.removeChild(addPanel);
    				mainPanel.style.height = null;
					console.log(json);
					callback(json);
					
				}else{
					
					alert(json["message"]);
					
				}
				loadingPanel.setAttribute("class", "hidden_panel");
								
			});
    		
    	}
    	
		
    }
	
}

function editItem(columns, editKey, mainPanel, columnsPanel, mode, itemData, inputTypeList, callback){
	
	console.log("editKey = " + editKey);
	
	console.log(columns[editKey]);
	console.log(itemData);
	
	var addPanel = document.createElement("div");
	addPanel.id = "addCoursePanel";
	//columnsPanel.appendChild(addPanel);
	
    var inputData = {};
    //var inputTypeList = setting_data['courseData'];
    if(mode == 'updateCourse'){
    	
    	inputTypeList["name"]["value"] = itemData["name"];
    	inputTypeList["active"]["value"] = itemData["active"];
    	if(itemData["cost"] != null){
    		
    		//inputTypeList["cost"]["value"] = parseFloat(itemData["cost"]);
    		inputTypeList["cost"]["value"] = parseInt(itemData["cost"]);
    		
    	}
    	inputTypeList["time"]["value"] = parseInt(itemData["time"]);
    	var courseTimeList = {};
    	for(var i = 5; i < 1440; i += 5){
    	
    		courseTimeList[i] = i + "min";
    	
		}
    	inputTypeList['time']['valueList'] = courseTimeList;
    	
    }else if(mode == 'updateForm'){
    	
    	inputTypeList["id"]["value"] = itemData["id"];
    	inputTypeList["name"]["value"] = itemData["name"];
    	inputTypeList["type"]["value"] = itemData["type"];
    	inputTypeList["active"]["value"] = itemData["active"];
    	inputTypeList["required"]["value"] = itemData["required"];
    	inputTypeList["isName"]["value"] = itemData["isName"];
    	inputTypeList["isAddress"]["value"] = itemData["isAddress"];
    	inputTypeList["isEmail"]["value"] = itemData["isEmail"];
    	inputTypeList["options"]["value"] = itemData["options"];
    	
    }
    
    var index = 0;
	console.log(inputTypeList);
	
	var table = document.createElement("table");
	table.setAttribute("class", "form-table");
	
	var trList = {}
	for(var key in inputTypeList){
		
		console.log(key);
        var data = inputTypeList[key];
        
        var th = document.createElement("th");
        th.setAttribute("scope", "row");
        th.textContent = i18n.get(inputTypeList[key].name);
        
        var inputPanel = createInput(key, data, inputData, false, false);
        var td = document.createElement("td");
        td.appendChild(inputPanel);
        
        var tr = document.createElement("tr");
        tr.setAttribute("valign", "top");
        tr.appendChild(th);
        tr.appendChild(td);
        trList[key] = tr;
        table.appendChild(tr);
		
	}
	
	if(inputData.id && inputData.id.textBox){
		
		console.log(inputData.id);
		inputData.id.textBox.disabled = true;
		
	}
	
    addPanel.appendChild(table);
    
    var cancelButton = document.createElement("button");
    cancelButton.setAttribute("style", "margin-right: 10px;");
    cancelButton.textContent = i18n.get("Cancel");
    cancelButton.setAttribute("class", "w3tc-button-save button-primary");
    
    var saveButton = document.createElement("button");
    saveButton.textContent = i18n.get("Save");
    saveButton.setAttribute("class", "w3tc-button-save button-primary");
    
    var buttonPanel = document.createElement("div");
    buttonPanel.setAttribute("style", "text-align: right; margin: 10px 10px 10px 0px;");
    buttonPanel.appendChild(cancelButton);
    buttonPanel.appendChild(saveButton);
    addPanel.appendChild(buttonPanel);
    
    console.log("addPanel Height = " + addPanel.clientHeight);
    
    var plusHeight = addPanel.clientHeight - columns[editKey].clientHeight;
    var height = addPanel.clientHeight;
    
    console.log(columns[editKey]);
    columns[editKey].setAttribute("class", "hidden_panel");
    columnsPanel.insertBefore(addPanel, columns[editKey]);
    
    
    var index = 0;
	for(var key in columns){
		
		if(key == editKey){
			
			break;
		}
		
	}
    
	console.log(columns);
	console.log("height = " + height);
	columnsPanel.style.height = height + "px";
    
    cancelButton.onclick = function(event){
    	
    	columnsPanel.removeChild(addPanel);
    	columns[key].setAttribute("class", "dnd_column ui-sortable-handle");
    	callback('cancel');
    	
    }
    
    saveButton.onclick = function(event){
    	
    	var response = null;
    	var postData = {mode: mode, nonce: nonce, action: action};
    	if(mode == 'updateCourse'){
    		
    		console.log(inputData);
    		postData['key'] = itemData['key'];
    		response = getInputData(inputTypeList, inputData);
			
    	}else if(mode == 'updateForm'){
    		
    		postData['key'] = editKey;
    		response = getInputData(inputTypeList, inputData);
    		response.id = itemData.id;
    		
    	}
    	
    	var post = true;
    	for(var key in response){
    			
    		if(typeof response[key] == 'boolean'){
    			
    			console.log("error key = " + key + " bool = " + response[key]);
    			trList[key].classList.add("errorPanel");
    			post = false;
    			
    		}else{
    			
    			postData[key] = response[key];
    			trList[key].classList.remove("errorPanel");
    			
    		}
    		
    	}
    	
    	if(post === true){
    		
    		loadingPanel.setAttribute("class", "loading_modal_backdrop");
    		console.log(itemData);
    		console.log(postData);
    		xmlHttp = new Booking_App_XMLHttp(url, postData, function(json){
				
				if(json['status'] != 'error'){
					
					//mainPanel.removeChild(addPanel);
    				mainPanel.style.height = null;
					console.log(json);
					callback(json);
					loadingPanel.setAttribute("class", "hidden_panel");
					
				}else{
					
					alert(json["message"]);
					
				}
									
			});
    		
    	}
    	
    }
	
}

function deleteItem(key, mode, callback){
	
	loadingPanel.setAttribute("class", "loading_modal_backdrop");
	var postData = {mode: mode, nonce: nonce, action: action, key: key};
    xmlHttp = new Booking_App_XMLHttp(url, postData, function(json){
					
		if(json['status'] != 'error'){
			
			callback(json);
			
		}
		loadingPanel.setAttribute("class", "hidden_panel");
								
	});
	
}

function sortData(key, className, list, panel, mode){
	
	console.log(list);
	var sortBool = false;
	var panelList = panel.getElementsByClassName(className);
	for(var i = 0; i < list.length; i++){
		
		var index = parseInt(panelList[i].getAttribute("data-key"));
		if(i != index){
			
			sortBool = true;
			break;
			
		}
		
	}
	
	var keyList = [];
	var indexList = [];
	if(sortBool === true){
		
		for(var i = 0; i < panelList.length; i++){
			
			keyList.push(list[i][key]);
			var index = parseInt(panelList[i].getAttribute("data-key"));
			indexList.push(index);
			console.log(panelList[i]);
			
		}
		
	}
	
	console.log(keyList);
	console.log(indexList);
	return sortBool;
	
}

function changeRank(key, className, list, panel, mode, callback){
	
	loadingPanel.setAttribute("class", "loading_modal_backdrop");
	var newList = [];
	var keyList = [];
	var indexList = [];
	
	var panelList = panel.getElementsByClassName(className);
	for(var i = 0; i < panelList.length; i++){
		
		
		var panelKey = parseInt(panelList[i].getAttribute("data-key"));
		newList.push(list[panelKey]);
		keyList.push(list[panelKey][key]);
		
		indexList.push(i);
		console.log(panelList[i]);
		
	}
	
	
	var postData = {mode: mode, nonce: nonce, action: action, keyList: keyList.join(","), indexList: indexList.join(",")};
	xmlHttp = new Booking_App_XMLHttp(url, postData, function(json){
		
		callback(json);
		loadingPanel.setAttribute("class", "hidden_panel");
			
	});
	
	return newList;
	
}


function addNewCourse1(callback){
	
	
	var media_frame_content = document.getElementById("media_frame_content")
	media_frame_content.textContent = null;
    var edit_title = document.getElementById("edit_title");
    edit_title.textContent = i18n.get("New service");
    
    document.getElementById("menu_panel").setAttribute("class", "media_frame_menu hidden_panel");
    document.getElementById("media_title").setAttribute("class", "media_left_zero");
    document.getElementById("media_router").setAttribute("class", "media_left_zero");
    document.getElementById("media_frame_content").setAttribute("class", "media_left_zero");
    document.getElementById("frame_toolbar").setAttribute("class", "media_frame_toolbar media_left_zero");
    
    var inputData = {};
    var courseDataList = setting_data['courseData'];
    var courseTimeList = {};
    var index = 0;
    for(var i = 5; i < 1440; i += 5){
    	
    	courseTimeList[i] = i + "min";
    	
    }
    
    courseDataList['time']['valueList'] = courseTimeList;
	console.log(courseDataList);
	
	var table = document.createElement("table");
	table.setAttribute("class", "form-table");
	
	for(var key in courseDataList){
		
		console.log(key);
        var courseData = courseDataList[key];
        
        var th = document.createElement("th");
        th.setAttribute("scope", "row");
        th.textContent = key;
        
        var inputPanel = createInput(key, courseData, inputData, false, false);
        var td = document.createElement("td");
        td.appendChild(inputPanel);
        
        var tr = document.createElement("tr");
        tr.setAttribute("valign", "top");
        tr.appendChild(th);
        tr.appendChild(td);
        table.appendChild(tr);
		
	}
    
    media_frame_content.appendChild(table);
    editPanelShow(true);
	
}

function isJSON(arg) {
	
	arg = (typeof arg === "function") ? arg() : arg;
	if (typeof arg  !== "string") {
		return false;
	}
    
	try {
		arg = (!JSON) ? eval("(" + arg + ")") : JSON.parse(arg);
		return true;
	} catch (e) {
		return false;
	}
	
}

function syncPanel(){
	
	var google_calendar_api_panel = function(messagePanel, parse_url, bookingSyncList){
    	
    	console.log(bookingSyncList.booking_package_googleCalendar_json);
    	console.log(parse_url);
    	var sync_url = parse_url.scheme + "://" + parse_url.host + "/?webhook=google";
    	//document.getElementById("webhook_url_for_google").value = sync_url;
    	console.log("sync_url = " + sync_url);
    	if(parse_url.scheme != 'https'){
    		
    		
    		
    	}
    	
    	var client_email = "no value";
    	var booking_package_googleCalendar_json = bookingSyncList.booking_package_googleCalendar_json.value;
    	if(booking_package_googleCalendar_json != null && booking_package_googleCalendar_json.length != 0){
    		
    		if(isJSON(booking_package_googleCalendar_json)){
    			
    			var json = JSON.parse(booking_package_googleCalendar_json);
    			client_email = json.client_email;
    			console.log(client_email);
    			
    		}
    		
    		
    		
    	}
    	
    	var googleCalendarLink = document.getElementById("googleCalendarLink");
    	var url = "https://saasproject.net/googleCalendar/?sync_url=" + encodeURIComponent(sync_url) + "&client_email=" + encodeURIComponent(client_email);
    	googleCalendarLink.href = url;
    	
    	var google_calendar_api = document.getElementById("google_calendar_api").cloneNode(true);
    	google_calendar_api.classList.remove("hidden_panel");
    	google_calendar_api.setAttribute("class", "");
    	messagePanel.appendChild(google_calendar_api);
    	
    	/**
    	var google_calendar_api_manual = document.getElementById("google_calendar_api_manual");
    	var action = "open";
    	var google_calendar_api_click = document.getElementById("google_calendar_api_click");
    	google_calendar_api_click.onclick = function(event){
    		
    		if(action == "close"){
    			
    			action = "open";
    			google_calendar_api_click.setAttribute("class", "open");
    			google_calendar_api_manual.setAttribute("class", "hidden_panel");
    			
    		}else{
    			
    			action = "close";
    			google_calendar_api_click.setAttribute("class", "close");
    			google_calendar_api_manual.setAttribute("class", "");
    			
    		}
    		
    	}
    	**/
    	
    }
	
	console.log(bookingSyncList);
	var bookingSync_table = document.getElementById("bookingSync_table");
	bookingSync_table.textContent = null;
    var inputData = {};
    var messageList = {};
    messageList["iCal"] = i18n.get("By using iCal you can share calendars and reservations for Google Calendar, Apple Calendar, iCal format.");
    messageList["Google_Calendar"] = "";
    
    for(var i in bookingSyncList){
    	
    	var disabled = false;
    	
    	if(i == 'Google_Calendar'){
    		
    		if(typeof ExtensionsFunction != "function"){
    			
    			disabled = true;
    			
    		}
    		
    	}
    	
    	
    	var title = document.createElement("div");
    	title.classList.add("title");
    	title.textContent = i;
    	bookingSync_table.appendChild(title);
    	
    	if(messageList[i] != null){
    		
    		var message = document.createElement("div");
    		message.textContent = messageList[i];
    		bookingSync_table.appendChild(message);
    		if(i == 'Google_Calendar'){
    			
    			google_calendar_api_panel(message, bookingSyncList[i].parse_url, bookingSyncList[i]);
    			
    		}
    		
    	}
    	
    	var table = document.createElement("table");
    	table.setAttribute("class", "form-table");
    	bookingSync_table.appendChild(table);
    	for(var key in bookingSyncList[i]){
    		
    		console.log(bookingSyncList[i]);
    		var list = bookingSyncList[i][key];
    		var th = document.createElement("th");
    		th.setAttribute("scope", "row");
    		th.textContent = list.name;
			
			var inputPanel = createInput(key, list, inputData, disabled, false);
			if(list.inputType == "CUSTOMIZE"){
				
				console.log("CUSTOMIZE");
				var tokenDate = list;
				var tokenButton = document.createElement("Button");
				tokenButton.textContent = i18n.get("Refresh token");
				tokenButton.setAttribute("data-Key", key);
				tokenButton.setAttribute("class", "w3tc-button-save button-primary tokenButton");
				
				var tokenValue = document.createElement("div");
				tokenValue.textContent = tokenDate.home + "?ical=" + tokenDate.value;
				tokenValue.setAttribute("class", "tokenValue");
				inputPanel.appendChild(tokenValue);
				inputPanel.appendChild(tokenButton);
				
				tokenButton.onclick = function(){
					
					var key = this.getAttribute("data-key");
					refreshToken(key, function(new_token){
						
						console.log(new_token);
						tokenValue.textContent = tokenDate.home + "?ical=" + new_token.token;
						
					});
					
				}
				
			}
			
			
			var td = document.createElement("td");
			td.appendChild(inputPanel);
			
			if(list['type'] == 'radio' || list['type'] == 'check' || list['type'] == 'select'){
				
				console.log(list['type']);
				if(typeof list['valueList'] == 'object'){
					
					console.log(list['valueList']);
					
				}
			
			}
			
			var tr = document.createElement("tr");
			tr.setAttribute("valign", "top");
			tr.appendChild(th);
			tr.appendChild(td);
			table.appendChild(tr);
    		
    	}
    	
    	
		
	}
	
	console.log(inputData);
    if(inputData.booking_app_googleCalendar_json){
    	
    	console.log(inputData.booking_app_googleCalendar_json.textBox);
    	var errorMessage = 'To display "Client ID" here, enter JSON in "Service account".';
    	var client_id_for_google = document.getElementById("client_id_for_google");
    	var value = inputData.booking_app_googleCalendar_json.textBox.value;
    	if(value.length != 0){
    		
    		var value = JSON.parse(value);
    		var client_email = value.client_email;
    		client_id_for_google.value = client_email;
    		console.log(client_id_for_google);
    		
    	}else{
    		
    		client_id_for_google.value = errorMessage;
    		
    	}
    	
    	inputData.booking_app_googleCalendar_json.textBox.onchange = function(){
    		
    		var value = inputData.booking_app_googleCalendar_json.textBox.value;
    		var value = JSON.parse(value);
    		if(value.client_email){
    			
    			var client_email = value.client_email;
    			client_id_for_google.value = client_email;
    			console.log(client_email);
    			console.log(client_id_for_google);
    			
    		}else{
    			
    			client_id_for_google.value = errorMessage;
    			
    		}
    		
   		}
   		
   	}
   	
	document.getElementById("save_bookingSync").onclick = function(){
        
        var postData = {mode: 'setting', type: 'bookingSync', nonce: nonce, action: action};
        var input = new Input();
        console.log(inputData);
        var valueList = {};
        
        for(var i in bookingSyncList){
        	
        	/**
        	if(i == 'Mailgun' || i == 'Stripe'){
    		
    			if(typeof ExtensionsFunction != "function"){
    				
    				continue;
    				
    			}
    			
        	}
        	**/
        	
        	for(var key in bookingSyncList[i]){
				
				if(inputData[key] != null){
					
					console.log(key);
					console.log(bookingSyncList[i][key]);
					console.log(inputData[key]);
					var bool = input.inputCheck(key, bookingSyncList[i][key], inputData[key], valueList);
					var value = valueList[key].join(',');
					if(value.length == 0 && Object.keys(inputData[key]).length == 1 && bookingSyncList[i][key].inputType == "CHECK"){
						value = 0;
					}
					
					postData[key] = value;
					
				}
        	
			}
			
        }
        console.log(valueList);
        console.log(postData);
        
        if(postData.booking_package_googleCalendar_json.length != 0 && isJSON(postData.booking_package_googleCalendar_json) == false){
        	
        	//alert("The Service account must be in JSON format.");
        	var confirm = new Confirm();
        	confirm.alertPanelShow(i18n.get("Error"), i18n.get("The Service account must be in JSON format."), false, function(){});
        	
        	return null;
        	
        }
        
        var loadingPanel = document.getElementById("loadingPanel");
        loadingPanel.classList.remove("hidden_panel");
        xmlHttp = new Booking_App_XMLHttp(url, postData, function(json){
			
			console.log(json);
			loadingPanel.classList.add("hidden_panel");
									
		});
        
    }
	
}

function createSettingPanel(){
	
	console.log(settingList);
	var setting_table = document.getElementById("setting_table");
    var inputData = {};
    var messageList = {};
    messageList["Mailgun"] = i18n.get("Mailgun is an email automation service. It offers a complete cloud-based email service for sending, receiving and tracking email sent through your websites and applications.");
    messageList["Stripe"] = i18n.get('Stripe is the best way to accept payments online and in mobile apps.');
    
    for(var i in settingList){
    	
    	var disabled = false;
    	if(i == 'Mailgun' || i == 'Stripe'){
    		
    		if(typeof ExtensionsFunction != "function"){
    			
    			disabled = true;
    			
    		}
    		
    	}
    	
    	var title = document.createElement("div");
    	title.classList.add("title");
    	title.textContent = i;
    	setting_table.appendChild(title);
    	
    	if(messageList[i] != null){
    		
    		var message = document.createElement("div");
    		message.textContent = messageList[i];
    		setting_table.appendChild(message);
    		
    	}
    	
    	var table = document.createElement("table");
    	table.setAttribute("class", "form-table");
    	setting_table.appendChild(table);
    	for(var key in settingList[i]){
    		
    		var list = settingList[i][key];
    		var th = document.createElement("th");
    		th.setAttribute("scope", "row");
    		th.textContent = list.name;
			
			var idBool = false;
			if(i == 'Design'){
				idBool = true;
			}
			
			var inputPanel = createInput(key, list, inputData, disabled, idBool);
			var td = document.createElement("td");
			td.appendChild(inputPanel);
			
			
			
			if(list['type'] == 'radio' || list['type'] == 'check' || list['type'] == 'select'){
				
				console.log(list['type']);
				console.log(list.valueList);
				if(typeof list['valueList'] == 'object'){
					
					console.log(list['valueList']);
					
				}
			
			}
			
			var tr = document.createElement("tr");
			tr.setAttribute("valign", "top");
			tr.appendChild(th);
			tr.appendChild(td);
			table.appendChild(tr);
			
			if(i == 'Design' && list.js != null){
				
				
				(function( $ ) {
					
					$(function() {
						console.log("key = " + key);
						console.log($('#' + key));
						$('#' + key).wpColorPicker();
					
					});
				
				})( jQuery );
				
			}
    		
    	}
		
	}
    
    /**
    for(var key in settingList.General){
        
        console.log(key);
        var list = settingList.General[key];
        
        var th = document.createElement("th");
        th.setAttribute("scope", "row");
        th.textContent = list.name;
        
        var inputPanel = createInput(key, list, inputData);
        var td = document.createElement("td");
        td.appendChild(inputPanel);
        
        if(list['type'] == 'radio' || list['type'] == 'check' || list['type'] == 'select'){
            
            console.log(list['type']);
            if(typeof list['valueList'] == 'object'){
            
                console.log(list['valueList']);
                
            }
            
        }
        
        var tr = document.createElement("tr");
        tr.setAttribute("valign", "top");
        tr.appendChild(th);
        tr.appendChild(td);
        setting_table.appendChild(tr);
        
    }
    **/
    
    document.getElementById("save_setting").onclick = function(){
        
        var loadingPanel = document.getElementById("loadingPanel");
        loadingPanel.classList.remove("hidden_panel");
        
        var postData = {mode: 'setting', nonce: nonce, action: action};
        var input = new Input();
        console.log(inputData);
        var valueList = {};
        
        for(var i in settingList){
        	
        	if(i == 'Mailgun' || i == 'Stripe'){
    		
    			if(typeof ExtensionsFunction != "function"){
    				
    				continue;
    				
    			}
    			
        	}
        	
        	for(var key in settingList[i]){
				
				if(inputData[key] != null){
					
					console.log(key);
					console.log(settingList[i][key]);
					console.log(inputData[key]);
					var bool = input.inputCheck(key, settingList[i][key], inputData[key], valueList);
					var value = valueList[key].join(',');
					if(value.length == 0 && Object.keys(inputData[key]).length == 1 && settingList[i][key].inputType == "CHECK"){
						value = 0;
					}
					
					postData[key] = value;
					
				}
        	
			}
			
        }
        /**
        for(var key in settingList){
        	
        	if(inputData[key] != null){
        		
        		console.log(key);
        		console.log(settingList[key]);
        		console.log(inputData[key]);
        		var bool = input.inputCheck(key, settingList[key], inputData[key], valueList);
        		postData[key] = valueList[key].join(',');
        		
        	}
        	
        	
        }
        **/
        
        console.log(valueList);
        console.log(postData);
        
        xmlHttp = new Booking_App_XMLHttp(url, postData, function(json){
			
			console.log(json);	
			loadingPanel.classList.add("hidden_panel");
									
		});
        
    }
	
}

function getInputData(inputTypeList, inputData){
	
	var postData = {};
	for(var key in inputTypeList){
    	
    	console.log(key);
    	var values = [];
    	var inputType = inputTypeList[key];
    	console.log(inputType);
    	for(var inputKey in inputData[key]){
    		
    		var bool = true;
    		if(inputType['inputType'] == 'TEXT' || inputType['inputType'] == 'TEXTAREA'){
    			
    			if(inputData[key][inputKey].value.length == 0 && inputType.inputLimit == '1'){
    				
    				bool = false;
    				
    			}else{
    				
    				values.push(inputData[key][inputKey].value);
    				
    			}
    			
    		}else if(inputType['inputType'] == 'CHECK' || inputType['inputType'] == 'RADIO'){
    			
    			if(inputData[key][inputKey].checked == true){
    				
    				values.push(inputData[key][inputKey].getAttribute("data-value"));
    				
    			}
    			
    		}else if(inputType['inputType'] == 'OPTION'){
    			
    			if(inputData[key][inputKey].checked == true){
    				
    				values.push(inputData[key][inputKey].value);
    				
    			}
    			
    		}else if(inputType['inputType'] == 'SELECT'){
    			
    			var index = inputData[key][inputKey].selectedIndex;
    			values.push(inputData[key][inputKey].options[index].value);
    			
    		}
    		
    	}
    	
    	if(bool === true){
    		
    		postData[key] = values.join(",");
    		
    	}else{
    		
    		postData[key] = false;
    		
    	}
    	
    	//postData[key] = false;
    	console.log(inputData[key]);
    	
    }
	
	return postData;
	
}

function createInput(inputName, input, inputData, disabled, idBool){
	
	console.log("createInput");
	console.log(input);
	var list = null;
	if(input['valueList'] != null){
	    
	    list = input['valueList'];
	    
	}
	
	console.log(list);
	var valuePanel = document.createElement("div");
	if(input['inputType'] == 'TEXT'){
		
		var textBox = document.createElement("input");
		textBox.setAttribute("class", "regular-text");
		textBox.type = "text";
		textBox.value = input['value'];
		textBox.disabled = disabled;
		if(idBool == true){
			
			textBox.id = inputName;
			
		}
		
		valuePanel.appendChild(textBox);
		inputData[inputName] = {textBox: textBox};
		
		
	}else if(input['inputType'] == 'SELECT'){
		
		var selectBox = document.createElement("select");
		selectBox.disabled = disabled;
		//for(var i = 0; i < list.length; i++){
		console.log(typeof list);
		console.log(list);
		for(var key in list){
			
			var optionBox = document.createElement("option");
			optionBox.value = key;
			optionBox.textContent = list[key];
			
			console.log("key = " + key + " content = " + list[key]);
			if(key == input['value']){
				
				console.log("value = " + input['value']);
				optionBox.selected = true;
				
			}
			
			selectBox.appendChild(optionBox);
			
			
		}
		
		valuePanel.appendChild(selectBox);
		inputData[inputName] = {selectBox: selectBox};
		
	}else if(input['inputType'] == 'SELECT_GROUP'){
		
		var selectBox = document.createElement("select");
		selectBox.disabled = disabled;
		//for(var i = 0; i < list.length; i++){
		console.log(typeof list);
		console.log(list);
		
		var selectedvalue = null;
		for(var key in list){
			
			if(list[key]['alpha-2'] == input['value']){
				
				selectedvalue = key;
				break;
				
			}
			
		}
		
		if(selectedvalue == null){
			
			selectedvalue = "United States of America";
			
		}
		
		var selectedCountry = list[selectedvalue];
		console.log(selectedCountry)
		
		var optionBox = document.createElement("option");
		optionBox.value = selectedCountry['alpha-2'];
		optionBox.textContent = selectedCountry.name;
		
		var optgroup = document.createElement("optgroup");
		optgroup.setAttribute("label", i18n.get("Selected country"));
		optgroup.appendChild(optionBox);
		selectBox.appendChild(optgroup);
		
		var frequently = ["Canada", "France", "Germany", "Italy", "Japan", "United Kingdom of Great Britain and Northern Ireland", "United States of America"];
		
		var optgroup = document.createElement("optgroup");
		optgroup.setAttribute("label", i18n.get("Frequently used countries"));
		selectBox.appendChild(optgroup);
		
		console.log("selectedvalue = " + selectedvalue);
		for(var i = 0; i < frequently.length; i++){
			
			var key = frequently[i];
			if(list[key].name != selectedvalue){
				
				var optionBox = document.createElement("option");
				optionBox.value = list[key]['alpha-2'];
				optionBox.textContent = list[key].name;
				optgroup.appendChild(optionBox);
				
			}
			
		}
		
		var optgroup = document.createElement("optgroup");
		optgroup.setAttribute("label", i18n.get("Other countries"));
		selectBox.appendChild(optgroup);
		
		for(var key in list){
			
			var optionBox = document.createElement("option");
			optionBox.value = list[key]['alpha-2'];
			optionBox.textContent = list[key].name;
			
			//console.log("key = " + key + " content = " + list[key]);
			if(key == input['value']){
				
				console.log("value = " + input['value']);
				optionBox.selected = true;
				
			}
			
			optgroup.appendChild(optionBox);
			
			
		}
		
		valuePanel.appendChild(selectBox);
		inputData[inputName] = {selectBox: selectBox};
		
	}else if(input['inputType'] == 'OPTION'){
		
		console.log("inputType = " + input['inputType']);
		console.log(input);
		var options = [];
		if(input['value'] != null){
			
			options = input['value'].split(",");
			
		}
		
		console.log(options);
		var addButton = document.createElement("label");
		//addButton.setAttribute("class", "w3tc-button-save button-primary");
		addButton.setAttribute("class", "addLink");
		addButton.textContent = i18n.get("Add");
		valuePanel.appendChild(addButton);
		
		var table = document.createElement("table");
		table.setAttribute("class", "table_option wp-list-table widefat fixed striped");
		valuePanel.appendChild(table);
		
		inputData[inputName] = {};
		var tr_index = 0;
		var table_tr = {};
		
		for(var i = 0; i < options.length; i++){
			
			create_tr(tr_index, table, options[i]);
			tr_index++;
			
		}
		
		addButton.onclick = function(){
			
			create_tr(tr_index, table, null);
			tr_index++;
			
		}
		
		
		
		
	}else if(input['inputType'] == 'CHECK'){
		
		inputData[inputName] = {};
		for(var key in list){
			
			console.log("key = " + key + " value = " + list[key])
			var valueName = document.createElement("span");
			valueName.setAttribute("class", "radio_title");
			valueName.textContent = list[key];
			
			var checkBox = document.createElement("input");
			checkBox.disabled = disabled;
			checkBox.setAttribute("data-value", key);
			checkBox.name = inputName;
			checkBox.type = "checkbox";
			checkBox.value = list[key];
			if(input['value'] == key){
				
				checkBox.checked = "checked";
				
			}
			
			var label = document.createElement("label");
			label.appendChild(checkBox);
			label.appendChild(valueName);
			valuePanel.appendChild(label);
			inputData[inputName][key] = checkBox;
			
		}
		
	}else if(input['inputType'] == 'RADIO'){
		
		inputData[inputName] = {};
		//for(var i = 0; i < list.length; i++){
	    for(var key in list){
			
			console.log(key + " = " + list[key]);
			var valueName = document.createElement("span");
			valueName.setAttribute("class", "radio_title");
			valueName.textContent = list[key];
			
			var radioBox = document.createElement("input");
			radioBox.disabled = disabled;
			radioBox.setAttribute("data-value", key);
			radioBox.name = inputName;
			radioBox.type = "radio";
			radioBox.value = list[key];
			if(input['value'] == key){
				
				console.log("value = " + input['value']);
				radioBox.checked = "checked";
				
			}
			
			var label = document.createElement("label");
			label.appendChild(radioBox);
			label.appendChild(valueName);
			valuePanel.appendChild(label);
			inputData[inputName][key] = radioBox;
			
		}
		
	}else if(input['inputType'] == 'TEXTAREA'){
		
		var textareaBox = document.createElement("textarea");
		textareaBox.value = input['value'];
		textareaBox.disabled = disabled;
		valuePanel.appendChild(textareaBox);
		inputData[inputName] = {textBox: textareaBox};
		
	}
	
	function create_tr(tr_index, table, value){
			
		var textBox = document.createElement("input");
		textBox.setAttribute("data-key", tr_index);
		textBox.setAttribute("class", "regular-text");
		textBox.setAttribute("style", "width: 100%");
		textBox.type = "text";
		
		var filedTd = document.createElement("td");
		filedTd.setAttribute("class", "td_option");
		filedTd.appendChild(textBox);
		
		var deleteButton = document.createElement("label");
		deleteButton.setAttribute("data-key", tr_index);
		deleteButton.setAttribute("class", "deleteLink");
		
		var deleteTd = document.createElement("td");
		deleteTd.setAttribute("class", "td_delete td_option");
		deleteTd.appendChild(deleteButton);
		
		var tr = document.createElement("tr");
		tr.setAttribute("class", "tr_option");
		tr.appendChild(filedTd);
		tr.appendChild(deleteTd);
		
		table_tr[tr_index] = tr;
		table.appendChild(tr);
		
		var checkBox = document.createElement("input");
		checkBox.setAttribute("data-value", tr_index);
		checkBox.name = tr_index;
		checkBox.type = "checkbox";
		checkBox.value = null;
		inputData[inputName][tr_index] = checkBox;
		
		if(value != null && value.length != 0){
			textBox.value = value;
			checkBox.value = value;
			checkBox.checked = true;
		}
		
		textBox.onchange = function(){
			
			var dataKey = this.getAttribute("data-key");
			var value = this.value;
			var bool = false;
			if(value.length != 0){
				bool = true;
			}else{
				value = null;
			}
			
			inputData[inputName][dataKey].value = value;
			inputData[inputName][dataKey].checked = bool;
			console.log("dataKey = " + dataKey + " value = " + value + " bool = " + bool);
			
		}
		
		deleteButton.onclick = function(){
			
			var result = false;
			var dataKey = this.getAttribute("data-key");
			var length = inputData[inputName][dataKey].value.length;
			if(length == 0){
				
				result = true;
				
			}
			
			if(result === false){
				
				//result = confirm("Do you delete option of \"" + inputData[inputName][dataKey].value + "\"?");
				result = confirm(i18n.get("Do you delete option of \"%s\"?", [inputData[inputName][dataKey].value]));
				
			}
			
			if(result === true){
				
				var tr = table_tr[parseInt(dataKey)];
				table.removeChild(tr);
				delete table_tr[dataKey];
				delete inputData[inputName][dataKey];
				console.log(tr);
				console.log(table_tr);
				console.log(inputData[inputName]);
				console.log("tr_index = " + tr_index);
				
			}
			
		}
			
	}
	
	return valuePanel;
	
}

var refreshToken = function(key, callback){
	
	console.log(key);
	var postData = {mode: "refreshToken", nonce: nonce, action: action, key: key};
	loadingPanel.setAttribute("class", "loading_modal_backdrop");
    xmlHttp = new Booking_App_XMLHttp(url, postData, function(json){
		
		if(json['status'] != 'error'){
			
			callback(json);
			
		}
		loadingPanel.setAttribute("class", "hidden_panel");
						
	});
	
}

var editPanelShow = function(showBool){
    
    var body = document.getElementsByTagName("body")[0];
    console.log(body);
    if(showBool == true){
        
        body.classList.add("modal-open");
        editPanel.setAttribute("class", "edit_modal");
        blockPanel.setAttribute("class", "edit_modal_backdrop");
        
    }else{
        
        body.classList.remove("modal-open");
        editPanel.setAttribute("class", "hidden_panel");
        blockPanel.setAttribute("class", "hidden_panel");
        
    }
    
}

